'use strict'
var request = require("request");
var xml2js = require('xml2js');

var Factura = require('../models/factura')
var moment = require('moment');
var dateFormat =  require('dateformat')
var {sqldb} = require('../db/sqlconnection');
const { query } = require('express');
const ThermalPrinter = require("node-thermal-printer").printer;
const Types = require("node-thermal-printer").types;
//Required package
var pdf = require("pdf-creator-node");
var fs = require('fs');
const path = require('path')
const emails = require('../emails/emails')
const util = require('util');
const { param } = require("../routes/restaurante");
const { parse } = require("path");



async function printTickets(items,params,printeripAddress,correlativo){
    
   
    let pKiosco = new ThermalPrinter({type: Types.EPSON, interface: printeripAddress.toString()});
    let cnKiosco =  await pKiosco.isPrinterConnected();
    console.log("Printer Kiosco connected 100:"+ printeripAddress.toString(), cnKiosco);

    

  /*  if(cnKiosco == false){
        return false
    }*/
   
    var index = 0
    while (index< items.length) {
        
        let actNom = items[index].producto.nombre;

        for (let i = 0; items[index].cantidad > i; i++){
            // let corrStr = '';
        // let ceros = '';

        // corrStr += correlativo;

        // for(let c = corrStr.length; c < 6; c++){
        //     ceros += '0';
        // }

        // corrStr = items[i].codigo + ceros + corrStr;
        
        await pKiosco.newLine();     
        await pKiosco.alignCenter();
        await pKiosco.printImage('./assets/logoblanco_sm.png');
        await pKiosco.newLine(); 

        await pKiosco.bold(true);
        await pKiosco.setTypeFontB();
        await pKiosco.setTextSize(1,2);  
        await pKiosco.println(actNom);
        await pKiosco.bold(false);
        
        await pKiosco.setTypeFontA();
        await pKiosco.setTextSize(0,0);
        await pKiosco.alignLeft();
        await pKiosco.println('No nos responsabilizamos por los accidentes y/o');
        await pKiosco.println('heridas causadas al utilizar las atracciones,');
        await pKiosco.println('usted sube bajo su cuenta y riesgo.Si el usuario');
        await pKiosco.println('no tiene un adecuado manejo de las atracciones,');
        await pKiosco.println('el personal tiene la autoridad de retirarlo sin');
        await pKiosco.println('devoluciones.');

        await pKiosco.cut();    
        }
        index = index+1
    }

   /* pKiosco.newLine();
    pKiosco.newLine();
    pKiosco.setTextSize(1,0);
    pKiosco.bold(true);
    pKiosco.alignCenter(); 
    pKiosco.printImage('./assets/logoblanco.png');
    pKiosco.println("ESTADO DE CUENTA");
    pKiosco.println("COPIA DEL CLIENTE");
    pKiosco.bold(false);
    pKiosco.setTextNormal(); 

    pKiosco.alignLeft(); 
    pKiosco.println("Usuario: " + params.usuarioAtendio);
    pKiosco.drawLine();

    pKiosco.tableCustom([
        { 
            text:"Cant.",
            align:"LEFT", 
            width:0.15
        },
        { 
            text: "Descripcion", 
            align:"LEFT", 
            width:0.64
        },
        { 
            text: "Total",
            align:"LEFT", 
            width:0.20 
        }
    ]);

     index = 0
    while (index< items.length) {
     
        pKiosco.tableCustom([
            { 
                text: items[index].cantidad,
                align:"LEFT", 
                width:0.15
            },
            { 
                text: items[index].platillo, 
                align:"LEFT", 
                width:0.64
            },
            { 
                text: "Q." + items[index].precio + ".00",
                align:"LEFT", 
                width:0.20
            }
        ]);
        index = index +1
    }

    pKiosco.drawLine();
    
    pKiosco.tableCustom([
        {text: "Total", align:"LEFT", width:0.75},
        {text: "Q." + params.total + ".00", align:"LEFT", width:0.25}
    ]);

    pKiosco.newLine();
    pKiosco.newLine();
    pKiosco.cut();*/

    await pKiosco.newLine();
    await pKiosco.newLine();
    await pKiosco.setTextSize(1,0);
    await pKiosco.bold(true);
    await pKiosco.alignCenter(); 
    await pKiosco.println("ESTADO DE CUENTA");
    await pKiosco.println("CONTROL DE CAJA");
    await pKiosco.bold(false);
    await pKiosco.setTextNormal(); 

    await pKiosco.alignLeft(); 
    await pKiosco.println("Usuario: " + params.usuarioAtendio);
    await pKiosco.drawLine();

    await pKiosco.tableCustom([
        { 
            text:"Cant.",
            align:"LEFT", 
            width:0.15
        },
        { 
            text: "Descripcion", 
            align:"LEFT", 
            width:0.64
        },
        { 
            text: "Total",
            align:"LEFT", 
            width:0.20 
        }
    ]); 

    index = 0
    var total_temp = 0
    while (index< items.length) {
        await pKiosco.tableCustom([
            { 
                text: items[index].cantidad,
                align:"LEFT", 
                width:0.15
            },
            { 
                text: items[index].platillo, 
                align:"LEFT", 
                width:0.64
            },
            { 
                text: "Q." + items[index].precio + ".00",
                align:"LEFT", 
                width:0.20
            }
        ]);
        total_temp = total_temp + (items[index].cantidad*items[index].precio)
        index = index +1
    }

    await pKiosco.drawLine();
    
    await pKiosco.tableCustom([
        {text: "Total", align:"LEFT", width:0.75},
        {text: "Q." + total_temp + ".00", align:"LEFT", width:0.25}
    ]);

    await pKiosco.newLine();
    await pKiosco.newLine();
    await pKiosco.println("Correlativo: " + correlativo);
    await pKiosco.cut();


     //console.log(pKiosco.getText()); 

    if(cnKiosco == false){
        return false
    }

   

    try {
        //console.log("EXECUTE!")
        let execute =   pKiosco.execute();
        return true;
      } catch (error) {
        const errorMessage = "Error de Conexion en Impresora "
        console.log(error)
        return false;
       
      }
  
   
    
}

async function printRecibo(params,printeripAddress,opencash,dateEmpresa,piepagina){
   

    const items = params.cuenta.productos
    let pKiosco = new ThermalPrinter({type: Types.EPSON, interface: printeripAddress.toString()});
    let cnKiosco =  await pKiosco.isPrinterConnected();
    console.log("Printer Recibo/Caja connected 100:"+ printeripAddress.toString(), cnKiosco);

    await pKiosco.newLine();
     
    await pKiosco.alignCenter();
    await pKiosco.printImage('./assets/logoblanco.png');
    await pKiosco.newLine();

    await pKiosco.bold(true);
    await pKiosco.println(dateEmpresa.nombreComercial ? dateEmpresa.nombreComercial: ''); //empresas.razonsocial
    await pKiosco.bold(false);
    await pKiosco.newLine();

    // Se quito la razon social y el nit porque no es un documento contable.
    await pKiosco.println(dateEmpresa.direccion ? dateEmpresa.direccion : ''); //empresas.direccion

    if(params.cuenta.nombreDelCliente && params.cuenta.nombreDelCliente.length>0){
        await pKiosco.newLine();

        pKiosco.println(params.cuenta.nombreDelCliente ? ("Cliente: " + params.cuenta.nombreDelCliente): '');
    }
   
   
    await pKiosco.newLine();
    
    await pKiosco.println('Comprobante de pago');
    await pKiosco.newLine();
    
    await pKiosco.drawLine();

    await pKiosco.tableCustom([
        { 
            text:"Cant.",
            align:"LEFT", 
            width:0.15
        },
        { 
            text: "Descripcion", 
            align:"LEFT", 
            width:0.64
        },
        { 
            text: "Total",
            align:"LEFT", 
            width:0.20 
        }
    ]);

    var index = 0
    while (index< items.length) {
       
        if(!items[index].cancelacion){
           
            await pKiosco.tableCustom([
                { 
                    text: items[index].cantidad,
                    align:"LEFT", 
                    width:0.15
                },
                { 
                    text: items[index].platillo, 
                    align:"LEFT", 
                    width:0.64
                },
                { 
                    text: "Q." + (parseInt(items[index].precio) * parseInt(items[index].cantidad)) + ".00",
                    align:"LEFT", 
                    width:0.20
                }
            ]);
            
        }
        index = index +1
    }
    
    await pKiosco.drawLine();

    await pKiosco.alignRight();
    await pKiosco.println('Sub-Total: Q ' + params.cuenta.subTotal);
    await pKiosco.println('Propina: Q ' + params.cuenta.propina);
    if(params.descuento > 0){
        await pKiosco.println('Descuento:  - Q ' + params.descuento);
    }
    await pKiosco.bold(true);
    await pKiosco.println('TOTAL: Q ' +params.cuenta.total);
    await pKiosco.bold(false);
    await pKiosco.alignCenter();
    //await printer.println('TRANSACCION: ' + data.idVentas);
    await pKiosco.newLine(); 
    
    await pKiosco.println(piepagina.line1 ? piepagina.line1 : '');
    await pKiosco.println(piepagina.line2 ? piepagina.line2 : '');
    await pKiosco.println(piepagina.line3 ? piepagina.line3 : '');
    await pKiosco.println(piepagina.line4 ? piepagina.line4 : '');
    await pKiosco.newLine(); 

    await pKiosco.alignCenter();
    await pKiosco.bold(true);
    await pKiosco.println('Documento No Contable');
    await pKiosco.bold(false);
    await pKiosco.drawLine(); 
    await pKiosco.println('powered by Proper');
    await pKiosco.println('www.somosproper.com');

    await pKiosco.newLine();
    await pKiosco.cut();
    // await pKiosco.tableCustom([
    //     {text: "Propina", align:"LEFT", width:0.75},
    //     {text: "Q." + params.cuenta.propina + ".00", align:"LEFT", width:0.25}
    // ]);

    // await pKiosco.tableCustom([
    //     {text: "Total", align:"LEFT", width:0.75},
    //     {text: "Q." + params.cuenta.total + ".00", align:"LEFT", width:0.25}
    // ]);

   
   // pKiosco.newLine();
   // pKiosco.newLine();
   // pKiosco.println("Correlativo: " + correlativo);

    if(opencash){
        await pKiosco.openCashDrawer(); 
    }

     //console.log(pKiosco.getText()); 

    if(cnKiosco == false){
        return false
    }

   

    try {
        //console.log("EXECUTE!")
        let execute =   pKiosco.execute();
        return true;
      } catch (error) {
        const errorMessage = "Error de Conexion en Impresora "
        console.log(error)
        return false;
       
      }
  
   
    
}

async function printFactura(data,params,printeripAddress,opencash,piepagina,dateEmpresa){
    let ts = Date.now();
    let tiempFecha = new Date(ts);

    // current date
    // adjust 0 before single digit date
    let date = ("0" + tiempFecha.getDate()).slice(-2);

    // current month
    let month = ("0" + (tiempFecha.getMonth() + 1)).slice(-2);

    // current year
    let year = tiempFecha.getFullYear();

    let fecha = date + '-' + month + '-' + year;
    
    // current hours
    let hours = tiempFecha.getHours();

    // current minutes
    let minutes = tiempFecha.getMinutes();

    // current seconds
    let seconds = tiempFecha.getSeconds();

    let tiempo = hours + ':' + minutes;   
    
    const items = params.cuenta.productos
    var printer_temp = ''
    if(printeripAddress && printeripAddress.length > 0){
        printer_temp =  printeripAddress[0].ipAddress
       
    }else{
        return false
    }

    let printer = new ThermalPrinter({type: Types.EPSON, interface: printer_temp.toString()});
    let printerConnection =  await printer.isPrinterConnected();
    console.log("Printer factura connected 100:"+ printer_temp.toString(), printerConnection);

    /*if(printerConnection == false){
        return false
    }*/
    

    await printer.alignCenter();
    await printer.printImage('./assets/logoblanco.png');

    await printer.bold(true);
    await printer.println(dateEmpresa.nombreComercial ? dateEmpresa.nombreComercial: ''); //empresas.nombreComercial
    await printer.bold(false);

    await printer.println(dateEmpresa.direccion ? dateEmpresa.direccion : ''); //empresas.direccion
    await printer.println(dateEmpresa.razonSocial ? dateEmpresa.razonSocial: ''); //empresas.razonsocial
    await printer.println("Nit: " + (dateEmpresa.nit ? dateEmpresa.nit: '')); //empresas.nit
    await printer.newLine();

    await printer.setTextSize(0,0);
    await printer.println('Factura Electronica');
    await printer.println('Autorizacion:');
    await printer.println(data.autorizacionFel);
    await printer.println('Fecha Certificacion: ' + data.fechaEmisionFel);
    await printer.newLine();

    
    await printer.alignLeft();
    await printer.println('Serie: '+ data.serie);
    await printer.println('Numero: '+ data.correlativo);
    await printer.println('NIT: '+data.nit);
    await printer.print('Fecha de Emision: '+ fecha);

    await printer.bold(true);
    await printer.println('   '+ tiempo);
    await printer.bold(false);

    await printer.alignLeft();
    await printer.println('NIT: '+data.nitComprador);
    await printer.println('Nombre: '+data.nombreComprador);
    await printer.println('Direccion: '+data.direccionC);

    if(params.cuenta.nombreDelCliente && params.cuenta.nombreDelCliente.length>0){
        await printer.setTextSize(1,0);
        await printer.bold(true);
        await printer.println(params.cuenta.nombreDelCliente ? ("Cliente: " + params.cuenta.nombreDelCliente): '');
        await printer.bold(false);
        await printer.setTextSize(0,0);
    }

    await printer.drawLine();

        if(params.descripcion.length == 0){
            await printer.tableCustom([
                { 
                    text:"Cant.",
                    align:"LEFT", 
                    width:0.15
                },
                { 
                    text: "Descripcion", 
                    align:"LEFT", 
                    width:0.64
                },
                { 
                    text: "Total",
                    align:"LEFT", 
                    width:0.20 
                }
            ]);
        
            var index = 0
            while (index< items.length) {
                if(!items[index].cancelacion){
                    await printer.tableCustom([
                        { 
                            text: items[index].cantidad,
                            align:"LEFT", 
                            width:0.15
                        },
                        { 
                            text: items[index].platillo, 
                            align:"LEFT", 
                            width:0.64
                        },
                        { 
                            text: "Q." + (parseInt(items[index].precio) * parseInt(items[index].cantidad)).toFixed(2)  ,
                            align:"LEFT", 
                            width:0.20
                        }
                    ]);
                   
                 }
                 index = index +1
            }
        }else if(params.descripcion.length > 0){
            await printer.tableCustom([
                { 
                    text:"",
                    align:"LEFT", 
                    width:0.15
                },
                { 
                    text: "Descripcion", 
                    align:"LEFT", 
                    width:0.64
                },
                { 
                    text: "Total",
                    align:"LEFT", 
                    width:0.20 
                }
            ]);
             
            await printer.tableCustom([
                    { 
                        text: '',
                        align:"LEFT", 
                        width:0.15
                    },
                    { 
                        text: params.descripcion, 
                        align:"LEFT", 
                        width:0.64
                    },
                    { 
                        text: data.subTotal,
                        align:"LEFT", 
                        width:0.20
                    }
                ]);
        }
    
      
        await printer.drawLine();

        await printer.alignRight();
        await printer.println('Sub-Total: Q ' + data.subTotal);
        await printer.println('Propina: Q ' + data.propina);
        if(params.descuento > 0){
            await printer.println('Descuento:  - Q ' + params.descuento);
        }
        await printer.bold(true);
        await printer.println('TOTAL: Q ' + data.total);
        await printer.bold(false);
        await printer.drawLine();
        
        await printer.alignCenter();
       if(params.efectivo>0){
            await printer.tableCustom([
                { 
                    text:"EFECTIVO",
                    align:"LEFT", 
                    width:0.64
                },
                { 
                    text: "", 
                    align:"LEFT", 
                    width:0.15
                },
                { 
                    text: "Q. " + params.efectivo.toFixed(2),
                    align:"LEFT", 
                    width:0.20 
                }
            ]);
       }
       if(params.bac>0){
        await printer.tableCustom([
            { 
                text:"BAC",
                align:"LEFT", 
                width:0.64
            },
            { 
                text: "", 
                align:"LEFT", 
                width:0.15
            },
            { 
                text: "Q. " + params.bac.toFixed(2),
                align:"LEFT", 
                width:0.20 
            }
        ]);
       }
       if(params.visa>0){
        await printer.tableCustom([
            { 
                text:"VISA",
                align:"LEFT", 
                width:0.64
            },
            { 
                text: "", 
                align:"LEFT", 
                width:0.15
            },
            { 
                text: "Q. " + params.visa.toFixed(2),
                align:"LEFT", 
                width:0.20 
            }
        ]);
       }
       if(params.glovoefectivo>0){
        await printer.tableCustom([
            { 
                text:"GLOVO EFECTIVO",
                align:"LEFT", 
                width:0.64
            },
            { 
                text: "", 
                align:"LEFT", 
                width:0.15
            },
            { 
                text: "Q. " + params.glovoefectivo.toFixed(2),
                align:"LEFT", 
                width:0.20 
            }
        ]);
       }
       if(params.glovoCredito>0){
        await printer.tableCustom([
            { 
                text:"GLOVO CREDITO",
                align:"LEFT", 
                width:0.64
            },
            { 
                text: "", 
                align:"LEFT", 
                width:0.15
            },
            { 
                text: "Q. " + params.glovoCredito.toFixed(2),
                align:"LEFT", 
                width:0.20 
            }
        ]);
       }
       if(params.hugoCredito>0){
        await printer.tableCustom([
            { 
                text:"HUGO CREDITO",
                align:"LEFT", 
                width:0.64
            },
            { 
                text: "", 
                align:"LEFT", 
                width:0.15
            },
            { 
                text: "Q. " + params.hugoCredito.toFixed(2),
                align:"LEFT", 
                width:0.20 
            }
        ]);
       }
       if(params.juntaDirectiva>0){
        await printer.tableCustom([
            { 
                text:"Junta Directiva",
                align:"LEFT", 
                width:0.64
            },
            { 
                text: "", 
                align:"LEFT", 
                width:0.15
            },
            { 
                text: "Q. " + params.juntaDirectiva.toFixed(2),
                align:"LEFT", 
                width:0.20 
            }
        ]);
       }
        //await printer.println('TRANSACCION: ' + data.idVentas);

        await printer.println(dateEmpresa.website);     

        await printer.println(piepagina.line1 ? piepagina.line1 : '');
        await printer.println(piepagina.line2 ? piepagina.line2 : '');
        await printer.println(piepagina.line3 ? piepagina.line3 : '');
        await printer.println(piepagina.line4 ? piepagina.line4 : '');
        await printer.newLine(); 

        await printer.alignCenter();
        await printer.bold(true);
        await printer.println('Documento Eletronico');
        await printer.println('Sujeto a pagos trimestrales');
        await printer.bold(false);
        await printer.println('DIGIFACT, S.A');
        await printer.println('NIT: 77454820');
        await printer.drawLine(); 
        await printer.println('powered by Proper')
        await printer.println('www.somosproper.com')

        await printer.cut();

        if(opencash){
            await printer.openCashDrawer(); 
        }
 
        //console.log(printer.getText());
        

        if(printerConnection == false){
            return false
        }

    try {
        //console.log("EXECUTE!")
        let execute =   printer.execute();
        return true;
      } catch (error) {
        const errorMessage = "Error de Conexion en Impresora "
        console.log(error)
        return false;
       
      }
  
   
    
}

async function guardarFactura(req, res) {
    let params = req.body;
    var suma = 0;
    suma = (params.dolares*params.tasaDeCambio) + params.hugoCredito+ params.glovoefectivo+params.glovoCredito+ params.bac+params.visa+params.efectivo+params.credito+params.cortesia+params.juntaDirectiva+params.descuento
   
    
    console.log("CUENTAA!") 
   

    //console.log(xml_products)           
    //return res.status(200).send({Error:"No existe la Cuenta"})
    try{

    const db =sqldb()
    const dbQuery = util.promisify(db.query).bind(db);
    var  sql = `SELECT * from cuentas WHERE id = ${params.cuenta._id}`;
    const result = await dbQuery(sql);
    if(result.Error){
        console.log(result.Error)
        res.status(200).send({Error:result.Error.toString()})
        db.end();
        return   
    }  
   
    if(result && result.length>0){
        const cuenta = result[0]
       
        
        if(!cuenta){
            res.status(200).send({Error:"No existe la Cuenta"})
            db.end();
            return  
        }
        
        if(Number( (suma).toFixed(2)) === Number( (cuenta.total).toFixed(2))){
            var idClientes = 0;
            if(params.faturado == true){
                  //  console.log("ENTRA VALOR")
                    sql = `SELECT *, LPAD(nit,12,0) as nitWS from empresas where id = '${process.env.idEmpresa}'`
                    const dbFact = await dbQuery(sql);
                    if(dbFact.Error){
                        console.log(dbFact.Error)
                        res.status(200).send({Error:dbFact.Error.toString()})
                        db.end();
                        return  
                    } 
                    
                     
                    if(dbFact && dbFact.length >0){
                        const dataEmpresa = dbFact[0]
                        const nitWS =  dataEmpresa.nitWS
                        var tipoDocumento = 'FACT'
                        if(dataEmpresa.tipoAfiliacion == 'PEQ'){
                            tipoDocumento = 'FPEQ'
                        }
                        const nowDate = new Date().toLocaleString('en-US', {
                            timeZone: 'America/Guatemala'
                          });
                         // console.log(nowDate)
                        const timGt = (new Date(nowDate)).toISOString()
                      
                       // console.log(timGt)
                        const date_ = nowDate.split(',')
                        const fechaEmision = date_[0].trim()
                        const horaEmision = date_[1].trim()
                        const codigoMoneda = 'GTQ'
                        const nitEmisor = dataEmpresa.nit
                        const nombreEmisor = dataEmpresa.razonSocial
                        //const codEstablecimiento = '1'
                        const codEstablecimiento = dataEmpresa.establecimiento
                        const nombreComercial = dataEmpresa.nombreComercial
                        const afiliacionIVA = dataEmpresa.tipoAfiliacion
                        const direccionEmisor = dataEmpresa.direccion
                        const codigoPostal = "0100"
                        const municipio = "GUATEMALA";
                        const depto = "GUATEMALA";
                        const pais = "GT";
                        var nombreComprador   ;
                        var nitComprador      ;
                        var direccionComprador;
                        if( params.nombre.toLowerCase() == 'cf' ||params.nit.toLowerCase() == 'cf' ||params.direccion.toLowerCase() == 'cf'){
                             nombreComprador    = 'Consumidor Final'
                             nitComprador       = 'CF'
                             direccionComprador = 'Consumidor Final'
                        }else{
                             nombreComprador = params.nombre
                             nitComprador = params.nit.replace("-",'')
                             direccionComprador = params.direccion
                        }
                        
                        const munComprador = "GUATEMALA";
                        const deptoComprador = "GUATEMALA";
                        const codigoPostalComprador = "01001";
                        const paisComprador = "GT";
                        var iva =  (((params.cuenta.total) / 1.12 * 0.12 * 100) / 100).toFixed(4);
                        var subTotal = (params.cuenta.total - iva).toFixed(4);
                        const url2 = process.env.FEL_URL + `?NIT=${nitWS}&TIPO=CERTIFICATE_DTE_XML_TOSIGN&FORMAT=XML`
                        const token2 = process.env.FEL_TOKEN

                        var iva_item2 =  ((((parseFloat(params.cuenta.propina)*parseInt(1))) / 1.12 * 0.12 * 100) / 100)
                        var subTotal_item2 = (((parseFloat(params.cuenta.propina))*parseInt(1)))/1.12
                        var tittle_propina = "propina"
                        var xml_products = `<dte:Item NumeroLinea="1" BienOServicio="S">
                                                        <dte:Cantidad>1</dte:Cantidad>
                                                        <dte:UnidadMedida>CA</dte:UnidadMedida>
                                                        <dte:Descripcion>${tittle_propina}</dte:Descripcion>
                                                        <dte:PrecioUnitario>${(parseInt(1)*parseFloat(params.cuenta.propina)).toFixed(4).toString()}</dte:PrecioUnitario>
                                                        <dte:Precio>${(parseInt(1)*parseFloat(params.cuenta.propina)).toFixed(4).toString()}</dte:Precio>
                                                        <dte:Descuento>0</dte:Descuento>`
                                if (afiliacionIVA !== 'PEQ') {
                                xml_products +=  `<dte:Impuestos>
                                                    <dte:Impuesto>
                                                        <dte:NombreCorto>IVA</dte:NombreCorto>
                                                        <dte:CodigoUnidadGravable>1</dte:CodigoUnidadGravable>
                                                        <dte:MontoGravable>${subTotal_item2.toFixed(4)}</dte:MontoGravable>
                                                        <dte:MontoImpuesto>${(iva_item2.toFixed(4))}</dte:MontoImpuesto>
                                                    </dte:Impuesto>
                                                </dte:Impuestos>`;
                                }
                                xml_products +=  `<dte:Total>${((parseInt(1)*parseFloat(params.cuenta.propina))).toFixed(4).toString()}</dte:Total>
                                </dte:Item>`;
                       
                        params.cuenta.productos.map(item=>{
                           
                            if(item.cancelacion == 0){
                                        var iva_item =  ((((parseFloat(item.precio)*parseInt(item.cantidad))-parseFloat(item.descuento)) / 1.12 * 0.12 * 100) / 100)
                                    var subTotal_item = (((parseFloat(item.precio))*parseInt(item.cantidad)) - (item.descuento))/1.12
                                    
                                    xml_products =   xml_products+ `<dte:Item NumeroLinea="1" BienOServicio="B">
                                                                        <dte:Cantidad>${item.cantidad}</dte:Cantidad>
                                                                        <dte:UnidadMedida>CA</dte:UnidadMedida>
                                                                        <dte:Descripcion>${item.platillo}</dte:Descripcion>
                                                                        <dte:PrecioUnitario>${item.precio}</dte:PrecioUnitario>
                                                                        <dte:Precio>${(parseInt(item.cantidad)*parseFloat(item.precio)).toFixed(4).toString()}</dte:Precio>
                                                                        <dte:Descuento>${item.descuento}</dte:Descuento>`
                                    if (afiliacionIVA !== 'PEQ') {
                                        xml_products +=  `<dte:Impuestos>
                                                                    <dte:Impuesto>
                                                                        <dte:NombreCorto>IVA</dte:NombreCorto>
                                                                        <dte:CodigoUnidadGravable>1</dte:CodigoUnidadGravable>
                                                                        <dte:MontoGravable>${subTotal_item.toFixed(4)}</dte:MontoGravable>
                                                                        <dte:MontoImpuesto>${(iva_item.toFixed(4))}</dte:MontoImpuesto>
                                                                    </dte:Impuesto>
                                                                </dte:Impuestos>`;
                                    }
                                    xml_products +=  `<dte:Total>${((parseInt(item.cantidad)*parseFloat(item.precio))-item.descuento).toFixed(4).toString()}</dte:Total>
                                    </dte:Item>`
                            }
                            
                        })      
                       
                       
                        var xml_data = `<?xml version="1.0" encoding="UTF-8"?>
                        <dte:GTDocumento xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:dte="http://www.sat.gob.gt/dte/fel/0.2.0" Version="0.1">
                            <dte:SAT ClaseDocumento="dte">
                                <dte:DTE ID="DatosCertificados">
                                    <dte:DatosEmision ID="DatosEmision">
                                        <dte:DatosGenerales Tipo="${tipoDocumento}" FechaHoraEmision="${timGt}" CodigoMoneda="${codigoMoneda}" />
                                        <dte:Emisor NITEmisor="${nitEmisor}" NombreEmisor="${nombreEmisor}" CodigoEstablecimiento="${codEstablecimiento}" NombreComercial="${nombreComercial}" AfiliacionIVA="${afiliacionIVA}">
                                            <dte:DireccionEmisor>
                                                <dte:Direccion>${direccionEmisor}</dte:Direccion>
                                                <dte:CodigoPostal>${codigoPostal}</dte:CodigoPostal>
                                                <dte:Municipio>${municipio}</dte:Municipio>
                                                <dte:Departamento>${depto}</dte:Departamento>
                                                <dte:Pais>${pais}</dte:Pais>
                                            </dte:DireccionEmisor>
                                        </dte:Emisor>
                                        <dte:Receptor NombreReceptor="${nombreComprador}" IDReceptor="${nitComprador}">
                                            <dte:DireccionReceptor>
                                                <dte:Direccion>${direccionComprador}</dte:Direccion>
                                                <dte:CodigoPostal>${codigoPostalComprador}</dte:CodigoPostal>
                                                <dte:Municipio>${munComprador}</dte:Municipio>
                                                <dte:Departamento>${deptoComprador}</dte:Departamento>
                                                <dte:Pais>${paisComprador}</dte:Pais>
                                            </dte:DireccionReceptor>
                                        </dte:Receptor>
                                        <dte:Frases>
                                            <dte:Frase TipoFrase="${dataEmpresa.tipoFrase}" CodigoEscenario="${dataEmpresa.codigoEscenario}" />
                                        </dte:Frases>`;
                            xml_data +=   `<dte:Items>`

                            xml_data +=  xml_products
                           
                            /*`<dte:Item NumeroLinea="1" BienOServicio="B">
                                                    <dte:Cantidad>1.0000</dte:Cantidad>
                                                    <dte:UnidadMedida>CA</dte:UnidadMedida>
                                                    <dte:Descripcion>item</dte:Descripcion>
                                                    <dte:PrecioUnitario>${params.cuenta.total}</dte:PrecioUnitario>
                                                    <dte:Precio>${params.cuenta.total}</dte:Precio>
                                                    <dte:Descuento>0</dte:Descuento>`
                            //GENERA IMPUESTOS SI LA AFILIACION NO ES PEQUENO CONTRIBUYENTE
                            if (afiliacionIVA !== 'PEQ') {
                                xml_data +=  `<dte:Impuestos>
                                                            <dte:Impuesto>
                                                                <dte:NombreCorto>IVA</dte:NombreCorto>
                                                                <dte:CodigoUnidadGravable>1</dte:CodigoUnidadGravable>
                                                                <dte:MontoGravable>${subTotal}</dte:MontoGravable>
                                                                <dte:MontoImpuesto>${iva}</dte:MontoImpuesto>
                                                            </dte:Impuesto>
                                                        </dte:Impuestos>`;
                            }
                            xml_data +=  `<dte:Total>${params.cuenta.total}</dte:Total>
                                                    </dte:Item>`*/

                            xml_data +=   `</dte:Items>`;
                            //TERMINA DETALLE DE LA FACTURA
                            xml_data += `<dte:Totales>`;

                            //GENERA IMPUESTOS SI LA AFILIACION NO ES PEQUENO CONTRIBUYENTE
                            if (afiliacionIVA !== 'PEQ') {
                             
                                xml_data +=   `<dte:TotalImpuestos>
                                                        <dte:TotalImpuesto NombreCorto="IVA" TotalMontoImpuesto="${iva}" />
                                                         </dte:TotalImpuestos>`;
                            }

                            xml_data += `<dte:GranTotal>${params.cuenta.total}</dte:GranTotal>
                            </dte:Totales>`;
                            xml_data += `</dte:DatosEmision>
                                        </dte:DTE>
                                            </dte:SAT>
                                        </dte:GTDocumento>`
                           
                           // console.log(xml_data)
                           
                          
                             var options = {
                                 method: 'POST',
                                 keepAlive: false,
                                 url: url2,
                                 headers: {
                                    'Authorization':token2,
                                    'Content-Type': 'Content-Type: text/xml',
                                    'Accept-Encoding': 'gzip'
                                 },
                                 body: xml_data,
                                 gzip: true //depending on the webservice, this has to be false
                             };

                             
                        
                    process.env["NODE_TLS_REJECT_UNAUTHORIZED"] = 0;
                      //console.log(xml_data)
                    var x = request(options, async function (error, response, body) {
                            //I convert the response to JSON. This is not mandatory
                                
                            if(error){
                                console.log("ERROR")
                                console.log(error)
                                return   res.status(200).send({Error:error.toString()})
                            }else{
                                var fel_data = JSON.parse(body)
                                 console.log("fel_data",fel_data.Codigo) 
                                if(fel_data.Codigo == 1){

                                        var  idClientes = 0
                                        sql = `SELECT id from clientes where nitC= '${params.nit}' AND idEmpresas = '${process.env.idEmpresa}'`
                                        const result3 = await dbQuery(sql  );
                                        if(result3.Error){
                                            res.status(200).send({Error:result3.Error})
                                            db.end();
                                            return   
                                        }
                                        if(result3.length == 0 && !(params.nombre.toLowerCase() == 'cf') && !(params.nit.toLowerCase() == 'cf') && !(params.direccion.toLowerCase() == 'cf')){

                                            const clientData = {
                                                nombreC:params.nombre,
                                                nombreF:params.nombre,
                                                nitC:params.nit,
                                                direccionC:params.direccion,
                                                telefonoC:'',
                                                idTipoClientes:1,
                                                idEmpresas:process.env.idEmpresa,
                                                created_at:new Date(),
                                                
                                                }
                                            sql = 'INSERT INTO clientes SET ?'
                                            const result2 = await dbQuery(sql,clientData);
                                            if(result2.Error){
                                                res.status(200).send({Error:result2.Error})
                                                db.end();
                                                return   
                                            }
                                            if( params.nombre.toLowerCase() == 'cf' ||params.nit.toLowerCase() == 'cf' ||params.direccion.toLowerCase() == 'cf'){
                                                params.nit = 'CF'
                                                params.nombre = 'Consumidor Final'
                                                params.direccion = 'Consumidor Final'
                                                idClientes = 0
                                            }else{
                                                idClientes =  result2.insertId
                                            }
                                        
                                        
                                        }else{
                                            if( params.nombre.toLowerCase() == 'cf' ||params.nit.toLowerCase() == 'cf' ||params.direccion.toLowerCase() == 'cf'){
                                                params.nit = 'CF'
                                                params.nombre = 'Consumidor Final'
                                                params.direccion = 'Consumidor Final'
                                                idClientes = 0
                                            }else{
                                                const data2 = result3[0]
                                                idClientes = data2.id
                                            }
                                            
                                        }
                                        console.log("id del cliente!!!!!!!",idClientes)
                                        var documento = "FAC - " + fel_data.Serie.toString() + "-" + fel_data.NUMERO.toString()
                                                var fechaFactura = new Date()

                                                const cierreVentaData = {
                                                    serie:fel_data.Serie,
                                                    correlativo:fel_data.NUMERO,
                                                    autorizacionFel:fel_data.Autorizacion,
                                                    fechaEmisionFel:fel_data.Fecha_DTE,
                                                    fechaFactura:fechaFactura,
                                                    valorFactura:params.cuenta.total,
                                                    subtotal:params.cuenta.subTotal,
                                                    descuento:params.descuento,
                                                    descuentoP:'',
                                                    total:params.cuenta.total,
                                                    anticipo:0,
                                                    saldo:0,
                                                    iva:0,
                                                    tipoCambio:params.tasaDeCambio,
                                                    totalDolares:params.dolares,
                                                    totalEnLetras:'',
                                                    totalEnLetrasDolares:'',
                                                    nit:params.nit,
                                                    nombre:params.nombre,
                                                    direccion:params.direccion,
                                                    idTipoOperacion:1,
                                                    idTipoVenta:0,
                                                    conceptoVenta:'',
                                                    idUsuarios:req.user.id,
                                                    idSucursales:req.user.idSucursales,
                                                    idEmpresas:process.env.idEmpresa,
                                                    created_at:fechaFactura,
                                                    updated_at:null,
                                                    
                                                    idFormatos:0,
                                                    idPartidas:0,
                                                    statusCierre:'0',
                                                    anulacion:'0',
                                                    idAdminUser:null,
                                                    motivoAnulacion:null,
                                                    tipoTransaccion: '1',
                                                    anulacion_at:null,
                                                    idClientes:idClientes,
                                                    idVendedores:null,
                                                
                                                    }
                                                    sql = 'INSERT INTO ventas SET ?'
                                                    const dbVenta = await dbQuery(sql,cierreVentaData);
                                                    if(dbVenta.Error){
                                                        res.status(200).send({Error:dbVenta.Error})
                                                        db.end();
                                                        return   
                                                    }
                                                    const idVentas = await dbVenta.insertId

                                                        const propinaModel = {
                                        
                                                            producto: {
                                                            id: 0,
                                                            noCuenta: params.cuenta.cuenta,
                                                            opciones: '[]',
                                                            tipo: 'PROPINA',
                                                            nombre: 'PROPINA',
                                                            cancelacion: 0,
                                                            cantidad: '1',
                                                            impreso: 0,
                                                            comentario: '',
                                                            precio: params.cuenta.propina,
                                                            numeroMesa: params.cuenta.numeroMesa,
                                                            idCuenta: params.cuenta.cuenta._id,
                                                            codigo: 'PROPINA',
                                                            idAreaImpresora: 0,
                                                            precioCosto: params.cuenta.propina,
                                                            idEmpresas: req.user.idEmpresas,
                                                            idProductos: 0,
                                                            idTipoProductos:'0'
                                                        }
                                                    }
                                                
                                                    params.cuenta.productos.push(propinaModel)

                                                    var cont2 =0
                                                    while(cont2<params.cuenta.productos.length){
                                                        var producto = params.cuenta.productos[cont2].producto
                                                        var totalProducto = producto.cantidad*producto.precio
                                                        var totalcosto = producto.cantidad*producto.precioCosto
                                                        const ventadetallesData = {
                                                            idVentas:idVentas,
                                                            tipoProducto:producto.idTipoProductos,
                                                            idProductos:producto.idProductos,
                                                            sku:producto.codigo,
                                                            descLarga:producto.nombre,
                                                            cantidad:producto.cantidad,
                                                            precio:producto.precio,
                                                            precioDolares:0,
                                                            costo:producto.precioCosto,
                                                            total:totalProducto,
                                                            totalDolares:0,
                                                            totalCosto:totalcosto,
                                                            idUsuarios:req.user.id,
                                                            idSucursales:req.user.idSucursales,
                                                            idEmpresas:producto.idEmpresas
                                                            }
                                                        sql = 'INSERT INTO ventasDetalle SET ?'
                                                        var dbventasDetalle = await dbQuery(sql,ventadetallesData);
                                                        if(dbventasDetalle.Error){
                                                            res.status(200).send({Error:dbventasDetalle.Error})
                                                            db.end();
                                                            return   
                                                        }
                                                        cont2 = cont2 + 1
                                                    }
                                                    params.cuenta.productos.pop()
                                                    sql = `SELECT tipoProducto,idProductos,cantidad,idUsuarios,idSucursales,idEmpresas from ventasDetalle where idVentas= ${idVentas}`
                                                    const data = await dbQuery(sql);
                                                    if(data.Error){
                                                        res.status(200).send({Error:data.Error})
                                                        db.end();
                                                        return   
                                                    }

                                                    var index = 0
                                                    while(index < data.length){
                                                        if(data[index].tipoProducto == 3){
                                                            var temp_data2 = data[index] 
                                                            var sql2 =   `select a.idProductos, concat(c.sku,' - ',c.descLarga) as producto ,a.unidades ,ifnull((SELECT ifnull(saldo,0) FROM inventarios WHERE  idProductos = a.idProductos and ingresoA=2 and idPuntoIngreso= '${temp_data2.idSucursales}'     order by id desc limit 1),'0.00') as saldo, if(ifnull((SELECT  ifnull(saldo,0) FROM inventarios WHERE idProductos = a.idProductos and ingresoA=2 and idPuntoIngreso= '${temp_data2.idSucursales}' order by id desc limit 1),'0.00') < (a.unidades*'${temp_data2.cantidad}' ),'false','true') as action from productosComponentes as a left join inventario as b ON (a.idProductos = b.idProductos) inner join productos as c ON (a.idProductos = c.id) where a.idProductoPrincipal = '${temp_data2.idProductos}' group by c.sku;`
                                                            const data2 = await dbQuery(sql2);
                                                            if(data2.Error){
                                                                console.log(data2.Error)
                                                                res.status(200).send({Error:data2.Error.toString()})
                                                                db.end();
                                                                return  
                                                            } 


                                                            //console.log("data")
                                                            //console.log(data2)
                                                            var index2 = 0
                                                            var saldo = 0;
                                                            const operacion = 'salida'


                                                            if(data){
                                                                while(index2<data2.length){
                                                                    saldo = data2[index2].saldo - (data2[index2].unidades  * temp_data2.cantidad )
                                                                    sql = `insert into inventarios(ingresoA,idPuntoIngreso,documento,idProductos,${operacion},saldo,idUsuarios,idEmpresas,created_at) values('2', '${temp_data2.idSucursales}','${documento}','${data2[index2].idProductos}','${data2[index2].unidades}*${temp_data2.cantidad}','${saldo}','${temp_data2.idUsuarios}','${temp_data2.idEmpresas}','${fechaFactura}');`
                                                                    const result22 = await dbQuery(sql);
                                                                    if(result22.Error){
                                                                        console.log(result22.Error)
                                                                        res.status(200).send({Error:result22.Error.toString()})
                                                                        db.end();
                                                                        return   
                                                                    }  
                                                                    index2 = index2 +1
                                                                }
                                                            }
                                                                
                                                        }else if(data[index].tipoProducto == 1){
                                                            var saldo2 = 0
                                                            var temp_data = data[index] 
                                                            const operacion = 'salida'
                                                            
                                                        var sql3 = `select saldo from inventarios where ingresoA='2' and idPuntoIngreso= ${data[index].idSucursales} and idProductos= '${data[index].idProductos}' and idEmpresas='${data[index].idEmpresas}' order by id desc limit 1;`
                                                        const data3 = await dbQuery(sql3);
                                                        if(data3.Error){
                                                            console.log(data3.Error)
                                                            res.status(200).send({Error:data3.Error.toString()})
                                                            db.end();
                                                            return   
                                                        } 
                                                            if(data3){
                                                                if(data3.length>0){
                                                                     
                                                                    var temp_saldo = data3[0].saldo
                                                                    saldo2 = temp_saldo - temp_data.cantidad 
                                                                //    console.log("saldo2",saldo2)
                                                                    sql = `insert into inventarios(ingresoA,idPuntoIngreso,documento,idProductos,${operacion},saldo,idUsuarios,idEmpresas,created_at) values('2', '${temp_data.idSucursales}','${documento}','${temp_data.idProductos}','${temp_data.cantidad}','${saldo2}','${temp_data.idUsuarios}','${temp_data.idEmpresas}','${fechaFactura}');`
                                                                    const dta = await dbQuery(sql);
                                                                    if(dta.Error){
                                                                        console.log(dta.Error)
                                                                        res.status(200).send({Error:dta.Error.toString()})
                                                                        db.end();
                                                                        return  
                                                                    } 
                                                                }
                                                            }
                                                        }
                                                        index = index + 1
                                                    }
                                                    var productType2 = params.cuenta.productos.filter(e =>{
                                                                
                                                        return e.producto.idTipoProductos === parseInt( process.env.idproductosKioscoImpresion) && e.producto.impreso == false
                                                        
                                                    });
                                                
                                                
                                                    productType2.sort((a, b) => (a.idAreaImpresora > b.idAreaImpresora) ? 1 : -1)
                                                    var respPrinter = false
                                                    var id_area_impresora = 1
                                                    if(params.cuenta.tipoMesa.toLowerCase() == process.env.PRINTEKIOSCONAME){
                                                        if(params.cuenta.productos && params.cuenta.productos.length>0){
                                                            id_area_impresora =  params.cuenta.productos[0].idAreaImpresora
                                                        }
                                                    
                                                    // console.log("AREA IMPRESORAAA",id_area_impresora)
                                                
                                                    }
                                                    if(productType2 && productType2.length > 0){
                                                        id_area_impresora = productType2[0].idAreaImpresora
                                                    } 

                                                    sql = `SELECT ipAddress from area_Impresoras WHERE  idareaImpresora = ${id_area_impresora} AND idEmpresas = '${process.env.idEmpresa}'`;
                                                    var printerdata = []
                                                    printerdata = await dbQuery(sql);
                                                
                                                    if(printerdata.Error){
                                                        res.status(200).send({Error:printerdata.Error})
                                                        db.end();
                                                        return   
                                                    }
                                                    if(printerdata.length > 1){
                                                        sql = `SELECT ipAddress from area_Impresoras WHERE  idareaImpresora = ${id_area_impresora} AND idEmpresas = '${process.env.idEmpresa}' AND idUsuario ='${req.user.id}'`; 
                                                        printerdata = await dbQuery(sql);
                                                        if(printerdata.Error){
                                                            res.status(200).send({Error:printerdata.Error})
                                                            db.end();
                                                            return   
                                                        }
                                                    }

                                                    sql = `SELECT * from documentosCorrelativos where idUsuarios= '${req.user.id}' AND idDocumentos=20 AND idEmpresas = '${process.env.idEmpresa}'`
                                                    const result5 = await dbQuery(sql);
                                                    if(result5.Error){
                                                        res.status(200).send({Error:result5.Error})
                                                        db.end();
                                                        return  
                                                    } 
                                                    if(productType2 && productType2.length > 0){

                                                        if(!printerdata || printerdata.length == 0){
                                                            respPrinter = false

                                                        }
                                                            var index = 0
                                                            var sumofProducts = 0
                                                            while (index< productType2.length) {
                                                                sumofProducts = parseInt(sumofProducts +  parseInt(productType2[index].cantidad))
                                                                index = index + 1
                                                            }
                                                            var correlativo = parseInt(result5[0].correlativo) + sumofProducts
                                                            var correlativo_string = ( parseInt(result5[0].correlativo)+1).toString() + " - " + correlativo.toString()
                                                            if( (parseInt(result5[0].correlativo)+1) == correlativo){
                                                                    correlativo_string =  correlativo.toString()
                                                            }
                                                            respPrinter =  await printTickets(productType2,params.cuenta,printerdata[0].ipAddress,correlativo_string)

                                                            let  sql2 = `UPDATE documentosCorrelativos SET correlativo = ${correlativo.toString()} WHERE idUsuarios = ${req.user.id} AND idDocumentos=20 AND idEmpresas = '${process.env.idEmpresa}'`;
                                                            const result8 = await dbQuery(sql2);
                                                            if(result8.Error){
                                                                console.log(result8.Error)
                                                                res.status(200).send({Error:result8.Error.toString()})
                                                                db.end();
                                                                return   
                                                            }
                                                    }
                                                    var id_area_impresora = 1
                                                    if(params.cuenta.tipoMesa.toLowerCase() == process.env.PRINTEKIOSCONAME){
                                                        if(params.cuenta.productos && params.cuenta.productos.length>0){
                                                            id_area_impresora =  params.cuenta.productos[0].idAreaImpresora
                                                        }
                                                    // console.log("AREA IMPRESORAAA",id_area_impresora)
                                                
                                                    }
                                                    var factrespPrinter = false
                                                    sql = `SELECT ipAddress from area_Impresoras WHERE  idareaImpresora = ${id_area_impresora} AND idEmpresas = '${process.env.idEmpresa}'`;
                                                    var printerdata2 = [] 
                                                    printerdata2 = await dbQuery(sql);
                                                    if(printerdata2.Error){
                                                        console.log(printerdata2.Error)
                                                        res.status(200).send({Error:printerdata2.Error.toString()})
                                                        db.end();
                                                        return   
                                                    }

                                                    if(printerdata2.length > 1){
                                                        sql = `SELECT ipAddress from area_Impresoras WHERE  idareaImpresora = ${id_area_impresora} AND idEmpresas = '${process.env.idEmpresa}' AND idUsuario ='${req.user.id}'`; 
                                                        printerdata2 = await dbQuery(sql);
                                                        if(printerdata2.Error){
                                                            console.log(printerdata2.Error)
                                                            res.status(200).send({Error:printerdata2.Error.toString()})
                                                            db.end();
                                                            return   
                                                        }
                                                    }

                                                    
                                                    if(!printerdata2 || printerdata2.length == 0){
                                                        factrespPrinter = false

                                                    } 
                                                    
                                                const printer_data = {
                                                        serie:cierreVentaData.serie,
                                                        correlativo:cierreVentaData.correlativo,
                                                        nit:nitEmisor,
                                                        fechaEmision:fechaFactura.toDateString(),
                                                        nitComprador:params.nit,
                                                        nombreComprador:params.nombre,
                                                        direccionC:params.direccion,
                                                        subTotal:params.cuenta.subTotal,
                                                        propina: params.cuenta.propina,
                                                        total:params.cuenta.total,
                                                        idVentas:idVentas,
                                                        autorizacionFel:cierreVentaData.autorizacionFel,
                                                        fechaEmisionFel:cierreVentaData.fechaEmisionFel
                                                    }
                                                var opencahs_temp = false
                                                if(params.efectivo > 0){
                                                    opencahs_temp = true
                                                }
                                            
                                                const dataempresa1 = await dbQuery( `SELECT * FROM empresas where id = ${process.env.idEmpresa}` );
                                                if(dataempresa1.Error){
                                                    console.log(dataempresa1.Error)
                                                    res.status(200).send({Error:dataempresa1.Error})
                                                    db.end();
                                                    return   
                                                }
                                                const piepaginaprinter2 = await dbQuery( `SELECT * FROM pirnterpiepagina where idSucursales=${req.user.idSucursales} AND idEmpresas = ${parseInt(process.env.idEmpresa)} ` );
                                                if(piepaginaprinter2.Error){
                                                    console.log(piepaginaprinter2.Error)
                                                    res.status(200).send({Error:registrocuentas.Error})
                                                    db.end();
                                                    return   
                                                }
                                                factrespPrinter = await  printFactura(printer_data,params,printerdata2,opencahs_temp,piepaginaprinter2[0],dataempresa1[0])
                                                const data2 = {
                                                    total:params.cuenta.total,
                                                    subTotal:params.cuenta.subTotal,
                                                    propina:params.cuenta.propina,
                                                    nombreCliente:params.cuenta.nombreDelCliente,
                                                    numeroMesa:params.cuenta.numeroMesa,
                                                    tipodeMesa:params.cuenta.tipoMesa,
                                                    usuarioAtendio:params.cuenta.usuarioAtendio,
                                                    productos: JSON.stringify(params.cuenta.productos),
                                                    bac:params.bac,
                                                    glovoEfectivo:params.glovoefectivo,
                                                    glovoCredito:params.glovoCredito,
                                                    hugoCredito:params.hugoCredito,
                                                    visa:params.visa,
                                                    efectivo:params.efectivo,
                                                    credito:params.credito,
                                                    tasaDeCambio:params.tasaDeCambio,
                                                    dolares:params.dolares,
                                                    cortesia:params.cortesia,
                                                    descuento:params.descuento,
                                                    juntaDirectiva:params.juntaDirectiva,
                                                    idCuentaCorrelativo:params.cuenta._id,
                                                    idcierreCaja:0,
                                                    idEmpresas:process.env.idEmpresa,
                                                    idUsuarioAtendio:cuenta.idUsuarioAtendio,
                                                    idUsuarioCierre:req.user.id,
                                                    idVentas:idVentas
                                                }
                                            sql = 'INSERT INTO registrocuentas SET ?'
                                            const result2 = await dbQuery(sql,data2);
                                            if(result2.Error){
                                                console.log(result2.Error)
                                                res.status(200).send({Error:result2.Error})
                                                db.end();
                                                return   
                                            }
                                            var queryString = '(';
                                            var cont =0
                                            while(cont<params.cuenta.productos.length){
                                                
                                                if(cont<params.cuenta.productos.length-1){
                                                    queryString = queryString + params.cuenta.productos[cont]._id.toString() + ','
                                                }else{
                                                    queryString = queryString + params.cuenta.productos[cont]._id.toString() + ')'
                                                }
                                                
                                                cont = cont + 1

                                            }
                                        
                                            sql = `DELETE from productosencuenta WHERE id IN ` + queryString;
                                            const result = await dbQuery(sql);
                                            if(result.Error){
                                                console.log(result.Error)
                                                res.status(200).send({Error:result.Error})
                                                db.end();
                                                return   
                                            }

                                            sql = `DELETE from cuentas WHERE id = ${params.cuenta._id}`;
                                            const result_DELETE_cuentas = await dbQuery(sql);
                                            if(result_DELETE_cuentas.Error){
                                                console.log(result_DELETE_cuentas.Error)
                                                res.status(200).send({Error:result_DELETE_cuentas.Error})
                                                db.end();
                                                return   
                                            } 

                                            
                                            if(factrespPrinter == false){
                                                res.status(200).send({pinterError:"Error en la Impresion de Factura verifique la conexion"})
                                                db.end();
                                                return 
                                            
                                            }else{
                                                res.status(200).send(result2)
                                                db.end();
                                                return 
                                            } 
                                            
                                    }else{
                                    console.log("failed step FEL")
                                    console.log(fel_data) 
                                    res.status(200).send({Error:"failed step FEL"})
                                    db.end()
                                        return  
                                    } 
                        
                                
                            }     
                        });
                    }
                       
                  
                
            }else{

                    idClientes = 0
                     sql = `SELECT * from documentosCorrelativos where idUsuarios= '${req.user.id}' AND idDocumentos=14 AND idEmpresas = '${process.env.idEmpresa}'`
                
                    const result5 = await dbQuery(sql);
                    if(result5.Error){
                        console.log(result5.Error)
                        res.status(200).send({Error:result5.Error.toString()})
                        db.end();
                        return  
                    }
                    
                    if(result5.length> 0){
                        
                        var documento = "REC - " + result5[0].serie.toString() + "-" + result5[0].correlativo.toString()
                        var fechaFactura = new Date()

                        const cierreVentaData = {
                            serie:result5[0].serie,
                            correlativo:result5[0].correlativo,
                            fechaFactura: fechaFactura,
                            valorFactura:params.cuenta.total,
                            subtotal:params.cuenta.subTotal,
                            descuento:params.descuento,
                            descuentoP:'',
                            total:params.cuenta.total,
                            anticipo:0,
                            saldo:0,
                            iva:0,
                            tipoCambio:params.tasaDeCambio,
                            totalDolares:params.dolares,
                            totalEnLetras:'',
                            totalEnLetrasDolares:'',
                            nit:'CF',
                            nombre:'CF',
                            direccion:'CF',
                            idTipoOperacion:1,
                            idTipoVenta:0,
                            conceptoVenta:'',
                            idUsuarios:req.user.id,
                            idSucursales:req.user.idSucursales,
                            idEmpresas:process.env.idEmpresa,
                            created_at:fechaFactura,
                            updated_at:null,
                            
                            idFormatos:0,
                            idPartidas:0,
                            statusCierre:'0',
                            anulacion:'0',
                            idAdminUser:null,
                            motivoAnulacion:null,
                            
                            anulacion_at:null,
                            idClientes:idClientes,
                            idVendedores:null,
                            
                            }
                          
                            let sql = 'INSERT INTO ventas SET ?'
                           
                            const result2 = await dbQuery(sql,cierreVentaData);
                            if(result2.Error){
                                console.log(result2.Error)
                                res.status(200).send({Error:result2.Error.toString()})
                                db.end();
                                return   
                            }
                            var correlativo = parseInt(result5[0].correlativo) + 1
                            
                            let  sql2 = `UPDATE documentosCorrelativos SET correlativo = ${correlativo.toString()} WHERE idUsuarios = ${req.user.id} AND idDocumentos=14 AND idEmpresas = '${process.env.idEmpresa}'`;
                            const result8 = await dbQuery(sql2);
                            if(result8.Error){
                                console.log(result8.Error)
                                res.status(200).send({Error:result8.Error.toString()})
                                db.end();
                                return   
                            }

                            const idVentas = await result2.insertId

                            const propinaModel = {
            
                                producto: {
                                id: 0,
                                noCuenta: params.cuenta.cuenta,
                                opciones: '[]',
                                tipo: 'PROPINA',
                                nombre: 'PROPINA',
                                cancelacion: 0,
                                cantidad: '1',
                                impreso: 0,
                                comentario: '',
                                precio: params.cuenta.propina,
                                numeroMesa: params.cuenta.numeroMesa,
                                idCuenta: params.cuenta._id,
                                codigo: 'PROPINA',
                                idAreaImpresora: 0,
                                precioCosto: params.cuenta.propina,
                                idEmpresas: req.user.idEmpresas,
                                idProductos: 0,
                                idTipoProductos:'0'
                                }
                            }
                        
                            params.cuenta.productos.push(propinaModel)
                          
                                
                                    var cont2 =0
                                while(cont2<params.cuenta.productos.length){
                                    var producto = params.cuenta.productos[cont2].producto
                                    var totalProducto = producto.cantidad*producto.precio
                                    var totalcosto = producto.cantidad*producto.precioCosto
                                    
                                    const ventadetallesData = {
                                        idVentas:idVentas,
                                        tipoProducto:producto.idTipoProductos,
                                        idProductos:producto.idProductos,
                                        sku:producto.codigo,
                                        descLarga:producto.nombre,
                                        cantidad:producto.cantidad,
                                        precio:producto.precio,
                                        precioDolares:0,
                                        costo:producto.precioCosto,
                                        total:totalProducto,
                                        totalDolares:0,
                                        totalCosto:totalcosto,
                                        idUsuarios:req.user.id,
                                        idSucursales:req.user.idSucursales,
                                        idEmpresas:producto.idEmpresas
                                        }
                                    sql = 'INSERT INTO ventasDetalle SET ?'
                                    const result23 = await dbQuery(sql,ventadetallesData);
                                    if(result23.Error){
                                        console.log(result23.Error)
                                        res.status(200).send({Error:result23.Error.toString()})
                                        db.end();
                                        return   
                                    }
                                    
                                    
                                    cont2 = cont2 + 1
                                }
                                params.cuenta.productos.pop()
                                sql = `SELECT tipoProducto,idProductos,cantidad,idUsuarios,idSucursales,idEmpresas from ventasDetalle where idVentas= ${idVentas}`
                                const data = await dbQuery(sql);
                                if(data.Error){
                                    console.log(data.Error)
                                    res.status(200).send({Error:data.Error.toString()})
                                    db.end();
                                    return   
                                }
                                var index = 0
                                while(index < data.length){
                                    
                                
                                    if(data[index].tipoProducto == 3){
                                        var temp_data2 = data[index] 
                                        sql2 =   `select a.idProductos, concat(c.sku,' - ',c.descLarga) as producto ,a.unidades ,ifnull((SELECT ifnull(saldo,0) FROM inventarios WHERE  idProductos = a.idProductos and ingresoA=2 and idPuntoIngreso= '${temp_data2.idSucursales}'     order by id desc limit 1),'0.00') as saldo, if(ifnull((SELECT  ifnull(saldo,0) FROM inventarios WHERE idProductos = a.idProductos and ingresoA=2 and idPuntoIngreso= '${temp_data2.idSucursales}' order by id desc limit 1),'0.00') < (a.unidades*'${temp_data2.cantidad}' ),'false','true') as action from productosComponentes as a left join inventario as b ON (a.idProductos = b.idProductos) inner join productos as c ON (a.idProductos = c.id) where a.idProductoPrincipal = '${temp_data2.idProductos}' group by c.sku;`
                                        const data2 = await dbQuery(sql2);
                                        if(data2.Error){
                                            console.log(data2.Error)
                                            res.status(200).send({Error:data2.Error.toString()})
                                            db.end();
                                            return   
                                        } 


                                       //  console.log("data")
                                        //console.log(data2)
                                        var index2 = 0
                                        var saldo = 0;
                                        const operacion = 'salida'


                                        if(data){
                                            while(index2<data2.length){
                                                saldo = data2[index2].saldo - (data2[index2].unidades  * temp_data2.cantidad )
                                                sql = `insert into inventarios(ingresoA,idPuntoIngreso,documento,idProductos,${operacion},saldo,idUsuarios,idEmpresas,created_at) values('2', '${temp_data2.idSucursales}','${documento}','${data2[index2].idProductos}','${data2[index2].unidades}*${temp_data2.cantidad}','${saldo}','${temp_data2.idUsuarios}','${temp_data2.idEmpresas}','${fechaFactura}');`
                                                const result22 = await dbQuery(sql);
                                                if(result22.Error){
                                                    console.log(result22.Error)
                                                    res.status(200).send({Error:result22.Error.toString()})
                                                    db.end();
                                                    return   
                                                }  
                                                index2 = index2 +1
                                            }
                                        }
                                            
                                    }else if(data[index].tipoProducto == 1){
                                        var saldo2 = 0
                                        var temp_data = data[index] 
                                        const operacion = 'salida'
                                        
                                       var sql3 = `select saldo from inventarios where ingresoA='2' and idPuntoIngreso= ${data[index].idSucursales} and idProductos= '${data[index].idProductos}' and idEmpresas='${data[index].idEmpresas}' order by id desc limit 1;`
                                       const data3 = await dbQuery(sql3);
                                       if(data3.Error){
                                           console.log(data3.Error)
                                           res.status(200).send({Error:data3.Error.toString()})
                                           db.end();
                                           return   
                                       } 
                                        if(data3){
                                            if(data3.length>0){
                                                
                                                var temp_saldo = data3[0].saldo
                                                saldo2 = temp_saldo - temp_data.cantidad 
                                            //    console.log("saldo2",saldo2)
                                                sql = `insert into inventarios(ingresoA,idPuntoIngreso,documento,idProductos,${operacion},saldo,idUsuarios,idEmpresas,created_at) values('2', '${temp_data.idSucursales}','${documento}','${temp_data.idProductos}','${temp_data.cantidad}','${saldo2}','${temp_data.idUsuarios}','${temp_data.idEmpresas}','${fechaFactura}');`
                                                const dta = await dbQuery(sql);
                                                if(dta.Error){
                                                    console.log(dta.Error)
                                                    res.status(200).send({Error:dta.Error.toString()})
                                                    db.end();
                                                    return   
                                                } 
                                            }
                                        }
                                    }
                                    index = index + 1
                                }
                                var productType2 = params.cuenta.productos.filter(e =>{
                                        
                                    return e.producto.idTipoProductos === parseInt( process.env.idproductosKioscoImpresion) && e.producto.impreso == false
                                    
                                });
                                
                                productType2.sort((a, b) => (a.idAreaImpresora > b.idAreaImpresora) ? 1 : -1)
                                var respPrinter = false
                                var data_printer =  0
                                if(productType2 && productType2.length > 0){
                                    data_printer = productType2[0].idAreaImpresora
                                }
                                sql = `SELECT ipAddress from area_Impresoras WHERE  idareaImpresora = ${data_printer} AND idEmpresas = '${process.env.idEmpresa}'`;
                                const printerdata = await dbQuery(sql);
                                if(printerdata.Error){
                                    console.log(printerdata.Error)
                                    res.status(200).send({Error:printerdata.Error.toString()})
                                    db.end();
                                    return   
                                }
                                
                                
                                sql = `SELECT * from documentosCorrelativos where idUsuarios= '${req.user.id}' AND idDocumentos=20 AND idEmpresas = '${process.env.idEmpresa}'`
                                const result6 = await dbQuery(sql);
                                if(result6.Error){
                                    console.log(result6.Error)
                                    res.status(200).send({Error:result6.Error.toString()})
                                    db.end();
                                    return   
                                }
                                
                                if(productType2 && productType2.length > 0){
                                  

                                    if(!printerdata || printerdata.length == 0){
                                        respPrinter = false

                                    }
                                        var index = 0
                                        var sumofProducts = 0
                                        while (index< productType2.length) {
                                            sumofProducts = parseInt(sumofProducts +  parseInt(productType2[index].cantidad))
                                            index = index + 1
                                        }
                                        var correlativo = parseInt(result6[0].correlativo) + sumofProducts
                                        var correlativo_string = ( parseInt(result6[0].correlativo)+1).toString() + " - " + correlativo.toString()
                                        if( (parseInt(result6[0].correlativo)+1) == correlativo){
                                            correlativo_string =  correlativo.toString()
                                        }
                                        respPrinter =  await printTickets(productType2,params.cuenta,printerdata[0].ipAddress,correlativo_string)

                                        let  sql2 = `UPDATE documentosCorrelativos SET correlativo = ${correlativo.toString()} WHERE idUsuarios = ${req.user.id} AND idDocumentos=20 AND idEmpresas = '${process.env.idEmpresa}'`;
                                        const result8 = await dbQuery(sql2);
                                        if(result8.Error){
                                            console.log(result8.Error)
                                            res.status(200).send({Error:result8.Error.toString()})
                                            db.end();
                                            return  
                                        }
                                }
                               
                                var id_area_impresora = 1
                                if(params.cuenta.tipoMesa.toLowerCase() == process.env.PRINTEKIOSCONAME){
                                    if(params.cuenta.productos && params.cuenta.productos.length>0){
                                        id_area_impresora =  params.cuenta.productos[0].idAreaImpresora
                                    }
                                     // console.log("AREA IMPRESORAAA",id_area_impresora)
                                }
                                            
                                sql2 = `SELECT ipAddress from area_Impresoras WHERE  idareaImpresora = ${id_area_impresora} AND idEmpresas = '${process.env.idEmpresa}'`; 
                                var printerDATA = [];
                                printerDATA = await dbQuery(sql2);
                                if(printerDATA.Error){
                                    console.log(printerDATA.Error)
                                    res.status(200).send({Error:printerDATA.Error.toString()})
                                    db.end();
                                    return  
                                }
                              
                                if(printerDATA.length > 1){
                                    sql2 = `SELECT ipAddress from area_Impresoras WHERE  idareaImpresora = ${id_area_impresora} AND idEmpresas = '${process.env.idEmpresa}' AND idUsuario ='${req.user.id}'`; 
                                    printerDATA = await dbQuery(sql2);
                                    if(printerDATA.Error){
                                        console.log(printerDATA.Error)
                                        res.status(200).send({Error:printerDATA.Error.toString()})
                                        db.end();
                                        return  
                                    }
                                    
                                }

                                var opencahs_temp = false
                                if(params.efectivo > 0){
                                    opencahs_temp = true
                                }

                               
                                const dataempresa = await dbQuery( `SELECT * FROM empresas where id = ${process.env.idEmpresa}` );
                                if(dataempresa.Error){
                                    console.log(dataempresa.Error)
                                    res.status(200).send({Error:dataempresa.Error.toString()})
                                    db.end();
                                    return   
                                }
                               
                                const piepaginaprinter = await dbQuery( `SELECT * FROM pirnterpiepagina where idSucursales=${req.user.idSucursales} AND idEmpresas = ${parseInt(process.env.idEmpresa)} ` );
                                if(piepaginaprinter.Error){
                                    res.status(200).send({Error:registrocuentas.Error})
                                    db.end();
                                    return   
                                }
                                if(printerDATA.length == 0){
                                    respPrinter = await printRecibo(params,"",opencahs_temp,dataempresa[0],piepaginaprinter[0])
                                }else{
                                    respPrinter = await printRecibo(params,printerDATA[0].ipAddress,opencahs_temp,dataempresa[0],piepaginaprinter[0])
                                }
                               

                                const data2 = {
                                        total:params.cuenta.total,
                                        subTotal:params.cuenta.subTotal,
                                        propina:params.cuenta.propina,
                                        nombreCliente:params.cuenta.nombreDelCliente,
                                        numeroMesa:params.cuenta.numeroMesa,
                                        tipodeMesa:params.cuenta.tipoMesa,
                                        usuarioAtendio:params.cuenta.usuarioAtendio,
                                        productos: JSON.stringify(params.cuenta.productos),
                                        bac:params.bac,
                                        glovoEfectivo:params.glovoefectivo,
                                        glovoCredito:params.glovoCredito,
                                        hugoCredito:params.hugoCredito,
                                        visa:params.visa,
                                        efectivo:params.efectivo,
                                        credito:params.credito,
                                        cortesia:params.cortesia,
                                        dolares:params.dolares,
                                        tasaDeCambio:params.tasaDeCambio,
                                        descuento:params.descuento,
                                        juntaDirectiva:params.juntaDirectiva,
                                        idCuentaCorrelativo:params.cuenta._id,
                                        idcierreCaja:0,
                                        idEmpresas:process.env.idEmpresa,
                                        idUsuarioAtendio:cuenta.idUsuarioAtendio,
                                        idUsuarioCierre:req.user.id,
                                        idVentas:idVentas
                                } 
                                sql = 'INSERT INTO registrocuentas SET ?'
                                const result2_ = await dbQuery(sql,data2);
                                if(result2_.Error){
                                    console.log(result2_.Error)
                                    res.status(200).send({Error:result2_.Error.toString()})
                                    db.end();
                                    return  
                                }
                                var queryString = '(';
                                var cont =0
                                while(cont<params.cuenta.productos.length){
                                    
                                    if(cont<params.cuenta.productos.length-1){
                                        queryString = queryString + params.cuenta.productos[cont]._id.toString() + ','
                                    }else{
                                        queryString = queryString + params.cuenta.productos[cont]._id.toString() + ')'
                                    }
                                    
                                    cont = cont + 1

                                }
                                
                                sql = `DELETE from productosencuenta WHERE id IN ` + queryString;
                                const result2_delete_prdocuenta = await dbQuery(sql);
                                if(result2_delete_prdocuenta.Error){
                                    console.log(result2_delete_prdocuenta.Error)
                                    res.status(200).send({Error:result2_delete_prdocuenta.Error.toString()})
                                    db.end();
                                    return   
                                }    

                            
                                sql = `DELETE from cuentas WHERE id = ${params.cuenta._id}`;
                                const result2_delete_cuentas = await dbQuery(sql);
                                if(result2_delete_cuentas.Error){
                                    console.log(result2_delete_cuentas.Error)
                                    res.status(200).send({Error:result2_delete_cuentas.Error.toString()})
                                    db.end();
                                    return   
                                }  
                                //db.end();
                                //  console.log("SALE WUUU")
                                res.status(200).send(result2)
                                db.end();
                                return 
                               
                               
                    }else{
                        res.status(200).send({Error:"No existe el documento correlativo"})
                        db.end();
                        return 
                    }
                
                
        }
         
          }else{
            res.status(200).send({Error:"total cuenta"})
            db.end();
              return 
          }
       }else{
        res.status(200).send({Error:"La cuenta no existe"})
        db.end();
        return  
       }
        
    
    }catch (error) {
        res.status(200).send({Error:error.toString()})
        console.log("dbEROR ", error.toString());
        db.end()
       
        
            
           
            return  
     }
       

    
    
   
   // let factura = new Factura();
    //var date = dateFormat(new Date, "yyyy-mm-dd");

    //console.log(date)
  /*  if (params.nombre && params.nit && params.email && params.cuenta) {
        factura.nombre = params.nombre;
        factura.nit = params.nit;
        factura.email = params.email;
        factura.cuenta = params.cuenta;
        factura.bac = params.bac;
        factura.visa = params.visa;
        factura.efectivo = params.efectivo;
        factura.hotel = params.hotel;
        factura.cortesia = params.cortesia;
        factura.juntaDirectiva = params.juntaDirectiva;
        factura.fechaCierre = date
        factura.save((err, facturaGuardada) => {
            if (err) {
                res.status(500).send({ message: 'Error al guardar factura' })
            } else {
                if (!facturaGuardada) {
                    res.status(404).send({ message: 'No se pudo Guadar la factura' })
                } else {
                    // printFactura(facturaGuardada)
                    res.status(200).send({ facturaGuardada })
                }
            }
        });
    } else {
        res.status(200).send({ message: 'Ingrese todos los datos' })
    }*/
}

// function printFactura(factura) {
//     testConnection(factura)
// }

// async function testConnection(arg) {
//     let printer = new ThermalPrinter({
//         type: Types.EPSON,
//         interface: 'tcp://192.168.2.106'
//     });
//     // console.log()

//     let ts = Date.now()

//     let date_ob = new Date(ts)

//     let isConnected = await printer.isPrinterConnected();
//     console.log("Printer connected 100:", isConnected);

//     await printer.println("ESTADO DE CUENTA");
//     await printer.println(arg.cuenta[0].tipoMesa);
//     await printer.print("MESA ");
//     await printer.println(arg.cuenta[0].numeroMesa);
//     await printer.println(date_ob)
//     await printer.print("Usuario que lo atendio: ");
//     await printer.println(arg.cuenta[0].usuarioAtendio);
//     await printer.println("---------------------------------")
//     await printer.println("Platillos")
//     await printer.println(" ")
//     for (let i = 0; arg.cuenta[0].productos.length > i; i++) {
//         await printer.print(arg.cuenta[0].productos[i].cantidad)
//         await printer.print(" ")
//         await printer.println(arg.cuenta[0].productos[i].platillo)
//         for (let j = 0; arg.cuenta[0].productos[i].opciones.length > j; j++) {
//             await printer.print(" ")
//             await printer.println("+" + arg.cuenta[0].productos[i].opciones[j].seleccion)
//         }
//     }
//     await printer.println("------------------");
//     await printer.print("SubTotal ");
//     await printer.println(arg.cuenta[0].subTotal);
//     await printer.println("------------------");
//     await printer.print("Propina ");
//     await printer.println(arg.cuenta[0].propina);
//     await printer.println("------------------");
//     await printer.print("Total ");
//     await printer.println(arg.cuenta[0].total);
//     await printer.println("----------------------------------");
//     await printer.println("NIT");
//     await printer.println("----------------------------------");
//     await printer.println("EMAIL");
//     await printer.println("----------------------------------");
//     await printer.println("NOMBRE");
//     await printer.println("----------------------------------");
//     await printer.cut()


//     console.log(printer.getText());

//     try {
//         let execute = printer.execute();
//         let result = await execute;
//         console.error("Print done!", result);
//     } catch (error) {
//         console.log("Print failed:", error);
//     }

// }


function actualizarFactura(req, res) {
    let params = req.body;
    let facturaID = req.params.id;

    Factura.findByIdAndUpdate(facturaID, params, { new: true }, (err, facturaActualizada) => {
        if (err) {
            res.status(500).send({ message: 'Error al actualizar la factura' })
        } else {
            if (!facturaActualizada) {
                res.status(404).send({ message: 'No se pudo actualizar la factura' })
            } else {
                res.status(200).send({ message: 'La cuenta ha sido actualizada' })
            }
        }
    });
}

function eliminarFactura(req, res) {
    let facturaID = req.params.id;

    Factura.findByIdAndDelete(facturaID, (err, facturaEliminada) => {
        if (err) {
            res.status(500).send({ message: 'Error al eliminar la factura' })
        } else {
            if (!facturaEliminada) {
                res.status(404).send({ message: 'No se pudo actualizar la factura' })
            } else {
                res.status(200).send({ message: 'La factura ha sido eliminada' })
            }
        }
    })
}

function listarFacturas(req, res) {

    Factura.find((err, encontrado) => {
        if (err) {
            res.status(500).send({ message: 'Error al listar las facturas' })
        } else {
            if (!encontrado) {
                res.status(404).send({ message: 'No se pudo listar las facturas' })
            } else {
                res.status(200).send(encontrado)
            }
        }
    });
}

function buscarFactura(req, res) {
    let facturaID = req.params.id;

    Factura.findById(facturaID, (err, encontrado) => {
        if (err) {
            res.status(200).send({ Error: 'Error al buscar la factura' })
        } else {
            if (!encontrado) {
                res.status(200).send({ Error: 'No se pudo buscar la factura' })
            } else {
                res.status(200).send(encontrado)
            }
        }
    })
}

// { fecha: {$gte: Date(fechaBuscar), $lt: Date(fechaSiguiente)}
async function getTasaDeCambio(req, res) {
    
    
    let  sql = `SELECT tasaCambio from fondoCaja   WHERE idSucursales=${req.user.idSucursales}  AND date_cierre IS NULL ORDER BY ID DESC LIMIT 1`;
    if((parseInt(process.env.CIERRE_CAJA_PER_USER))){
        sql = `SELECT tasaCambio from fondoCaja WHERE idSucursales=${req.user.idSucursales} AND idUsuarios=${req.user.id} AND date_cierre IS NULL ORDER BY ID DESC LIMIT 1`;
    }
   
    const db =sqldb()
    await  db.query (sql,async(err,result)=>{
        
        if(err){
            console.log(err)
            res.status(200).send({Error:err.sqlMessage})
            db.end();
            return   
        }
        if(!result || result.length==0){
            res.status(200).send({Error:"no existe ninguna tasa de Cambio asociada a la Cuenta"})
            db.end();
            
            return   
        }else{
            res.status(200).send(result[0])
            db.end();
            return   
        }

    })
}
async function getFondoCaja(req, res) {
    let fechaBuscar = req.params.fechaEncontrar
    //let  sql = `SELECT * from fondoCaja WHERE idSucursales=${req.user.idSucursales} AND (DATE(date_apertura) = '${fechaBuscar}'  AND date_cierre IS NULL)`;
    let  sql = `SELECT * from fondoCaja   WHERE idSucursales=${req.user.idSucursales}  AND date_cierre IS NULL ORDER BY ID DESC LIMIT 1`;
    if((parseInt(process.env.CIERRE_CAJA_PER_USER))){
      //  console.log("ENTRAA!!!!!!!!!!!!!!!")
        sql = `SELECT * from fondoCaja WHERE idSucursales=${req.user.idSucursales} AND idUsuarios=${req.user.id} AND date_cierre IS NULL ORDER BY ID DESC LIMIT 1`;
    }
   
    const db =sqldb()
    await  db.query (sql,async(err,result)=>{
        
        if(err){
            console.log(err)
            res.status(200).send({Error:err.sqlMessage})
            db.end();
            return   
        }
     
        if(!result || result.length==0){
            res.status(200).send({data:"SET FONDO"})
            db.end();
            
            return   
        }else{
          
            res.status(200).send(result[0])
            db.end();
            return   
        }

    })
}

async function setFondoCaja(req, res) {
    const params = req.body
    
    const fondocaja = {
        monto:params.fondo,
        tasaCambio:params.tasaDeCambio,
        idUsuarios:req.user.id,
        idSucursales:req.user.idSucursales,
        date_apertura:new Date()
    }

    const db =sqldb()
    var sql = 'INSERT INTO fondoCaja SET ?'
    await db.query(sql,fondocaja,async(err,result2)=>{
        if(err){
            res.status(200).send({Error:err})
            console.log(err)
            db.end();
            return   
        }else{
            res.status(200).send(result2)
            console.log(result2)
            db.end();
            return  
        }
    })
  
    
}

async function buscarPorFecha(req, res) {
    let fechaBuscar = req.params.fechaEncontrar
    var ventaNeta = 0;
    var efectivo = 0
    var bac = 0
    var glovoEfectivo = 0;
    var hugoCredito = 0;
    var glovoCredito= 0;
    var visa = 0
    var credito = 0
    var cortesia = 0
    var descuento = 0
    var juntaDirectiva = 0
    var propina = 0
    var cuadre = 0
     
   
   
    //console.log("CUENTAA!",params.cuenta._id)
    try{
        const db =sqldb()
        const dbQuery = util.promisify(db.query).bind(db);
        let  sql = `SELECT * from cuentas WHERE idEmpresas=${process.env.idEmpresa}`;
        if((parseInt(process.env.CIERRE_CAJA_PER_USER))){
            sql = `SELECT * from cuentas WHERE idEmpresas=${process.env.idEmpresa} AND idUsuarioAtendio=${req.user.id}`;
        }

        
        const datacuentas = await dbQuery(sql );
      
        if(datacuentas.Error){
            return res.status(200).send({ Error:  datacuentas.Error.toString()})
        }
        if(datacuentas && datacuentas.length>0){
            if(datacuentas.length == 1){
                return res.status(200).send({ Error:  "Existe "+  datacuentas.length.toString()  +" Cuenta sin cobrar del usuario " + req.user.userName})
            }
            return res.status(200).send({ Error:  "Existen "+  datacuentas.length.toString()  +" Cuentas sin cobrar del  usuario " + req.user.userName})
        }
        if(datacuentas.result){
            console.log(result.Error.toString())
            return res.status(200).send({ Error:  result.Error.toString()})
        }

        if(parseInt(process.env.CIERRE_CAJA_PER_USER)){
            sql = `SELECT * from registrocuentas WHERE idcierreCaja=0 AND DATE(Fecha) = '${fechaBuscar}' AND idEmpresas = ${process.env.idEmpresa} AND idUsuarioAtendio = ${req.user.id}` ;
        }else{
            sql = `SELECT * from registrocuentas WHERE idcierreCaja=0 AND DATE(Fecha) = '${fechaBuscar}' AND idEmpresas = ${process.env.idEmpresa}` ;
        }
        //
       
        const result = await dbQuery(sql);
       
        
        var temp =  result.map(item => item.idUsuarioAtendio).filter((value, index, self) => self.indexOf(value) === index)
       
        var temp_cont_cantidad_propina = 0
        var array_object_temp = []
        for(let i = 0; temp.length > i; i++){
         
          var tipo_filtered = result.filter(e => {
            return (e.idUsuarioAtendio == temp[i])
          });
         
          temp_cont_cantidad_propina = 0
          for(let j = 0; tipo_filtered.length > j; j++){
            temp_cont_cantidad_propina = temp_cont_cantidad_propina  + (tipo_filtered[j].propina) 
          
            if(j == tipo_filtered.length-1){
               
                var userName = ''
                sql = `SELECT userName from usuarios WHERE id = ${temp[i]}  AND idEmpresas = ${process.env.idEmpresa}`;
                const dbUserName = await dbQuery(sql);

                if(dbUserName.Error){
                    return res.status(200).send({ Error:  dbUserName.Error.toString()})
                }
                if(dbUserName){
                    userName = dbUserName[0].userName
                }
               
             
              array_object_temp.push({
                  userName:userName,
                propina: temp_cont_cantidad_propina,
              })
            }
          }
        }
        //console.log(array_object_temp)
            if(result && result.length>0){
                for(let i = 0; result.length > i; i++){
                    var object = JSON.parse(result[i].productos)
                    for(let j = 0; object.length > j; j++){
                      if(object[j].platillo){
                          if(object[j].cancelacion == 0){
                            cuadre += object[j].precio * object[j].cantidad
                          }else{
                           // object[j].cantidad = 0
                          }
                          
                            
                        }
                     } 
                    

                     result[i].productos = JSON.stringify(object)
                     ventaNeta      += (result[i].total)
                     efectivo       += (result[i].efectivo)
                     bac            += (result[i].bac)
                     glovoEfectivo  += (result[i].glovoEfectivo)
                     glovoCredito   += (result[i].glovoCredito) 
                     hugoCredito   += (result[i].hugoCredito) 
                     visa           += (result[i].visa)
                     credito        += (result[i].credito)
                     cortesia       += (result[i].cortesia)
                     descuento      += (result[i].descuento)
                     juntaDirectiva += (result[i].juntaDirectiva)
                     propina        += (result[i].propina)

                } 

                 sql = `SELECT descripcion from familiaNivel2 WHERE idEmpresas = '${process.env.idEmpresa}' ORDER BY ordenMenu ASC`;
                 const family2order = await dbQuery(sql);
      
                 if(family2order.Error){
                     return res.status(200).send({ Error:  family2order.Error.toString()})
                 }
              
                    if( Number( (ventaNeta-propina+descuento ).toFixed(2))==  Number( (cuadre ).toFixed(2))){
                        res.status(200).send({result:result,userspropina:array_object_temp,familyorder:family2order})
                        db.end();
                        return 
                    }else{
                        console.log("ENTRA ERROR CUADREEEE")
                        res.status(200).send({result:result,userspropina:array_object_temp,familyorder:family2order,message :"Error En cuadre"})
                        db.end();
                        return 
                    }

                
            }else{
                res.status(200).send({ Error: 'No se encontro ninguna cuenta abierta para esta fecha' })
                db.end();
                return 
            }
            
        
    }catch (error) {
        res.status(200).send({Error:"db Error buscarPorFecha"})
        console.log(error)
       
        return  
    }
    //console.log(fechaBuscar)
    //let fechaSiguiente = Date(fechaBuscar).setDate(Date(fechaBuscar).getDate() + 1)
    // var fechaBuscarSplit = fechaBuscar.split('');
   
    
   /* Factura.find( { fechaCierre: fechaBuscar}, (err, encontrados) => {
        
        if (err) {
            res.status(500).send(err)
        } else {
            if (!encontrados) {
                res.status(404).send({ message: 'No se pudo buscar las facturas' })
            } else {
                res.status(200).send(encontrados)
             //   console.log(encontrados)
            }
        }
    })*/

}

async function generarCierrredeCaja(req, res) {
    let fechaBuscar = req.params.fechaEncontrar
    var params = req.body
    var ventaNeta = 0;
    var efectivo = 0
    var bac = 0
    var visa = 0
    var credito = 0
    var cortesia = 0
    var descuento = 0
    var juntaDirectiva = 0
    var propina = 0
    var cuadre = 0
    var glovoEfectivo = 0;
    var glovoCredito= 0;
    var hugoCredito= 0;
  
    var name_empresa = '';
    console.log(params)
    //console.log("CUENTAA!",params.cuenta._id)
    try{
        const db =sqldb()
        const dbQuery = util.promisify(db.query).bind(db);
        var registrocuentas
        if(parseInt(process.env.CIERRE_CAJA_PER_USER)){
            registrocuentas = await dbQuery( `SELECT * from registrocuentas WHERE idcierreCaja=0 AND DATE(Fecha) = '${fechaBuscar}' AND idEmpresas = ${process.env.idEmpresa} AND idUsuarioAtendio = ${req.user.id}`);
        }else{
            registrocuentas = await dbQuery( `SELECT * from registrocuentas WHERE idcierreCaja=0 AND DATE(Fecha) = '${fechaBuscar}' AND idEmpresas = ${process.env.idEmpresa}`);
        }
       
        //

       // console.log(registrocuentas)
        if(registrocuentas.Error){
            res.status(200).send({Error:registrocuentas.Error})
            db.end();
            return   
        }

        if(registrocuentas && registrocuentas.length>0){
            var  cierreFacturasPlatillos = []
             
              for(let i = 0; registrocuentas.length > i; i++){
                  var object = JSON.parse(registrocuentas[i].productos)
                  for(let j = 0; object.length > j; j++){
                    if(object[j].platillo){
                        if(object[j].cancelacion == 0){
                            cuadre += object[j].precio * object[j].cantidad
                            cierreFacturasPlatillos.push({
                                tipo:object[j].tipo,
                                platillo:object[j].platillo,
                                cantidad:object[j].cantidad,
                                precio:object[j].precio,
                                monto:object[j].precio*object[j].cantidad,
                                cancelacion:object[j].cancelacion
  
                            })
                        }else{
                            cierreFacturasPlatillos.push({
                                tipo:object[j].tipo,
                                platillo:object[j].platillo,
                                cantidad:object[j].cantidad,
                                precio:object[j].precio,
                                monto:object[j].precio*object[j].cantidad,
                                cancelacion:object[j].cancelacion
                            });
                            object[j].cantidad = 0;
                        }

                          
                         
                      }
                   } 
                    
                   registrocuentas[i].productos = JSON.stringify(object)
                   
                   ventaNeta      += (registrocuentas[i].total-registrocuentas[i].juntaDirectiva-registrocuentas[i].cortesia)
                   efectivo       += (registrocuentas[i].efectivo)
                   bac            += (registrocuentas[i].bac)
                   if(registrocuentas[i].glovoEfectivo){
                    glovoEfectivo  += (registrocuentas[i].glovoEfectivo)
                   }
                   if(registrocuentas[i].glovoCredito){
                    glovoCredito   += (registrocuentas[i].glovoCredito) 
                   }
                   if(registrocuentas[i].hugoCredito){
                    hugoCredito    += (registrocuentas[i].hugoCredito)
                   }
                  
                 
                  
                   visa           += (registrocuentas[i].visa)
                   credito        += (registrocuentas[i].credito)
                   cortesia       += (registrocuentas[i].cortesia)
                   descuento      += (registrocuentas[i].descuento)
                   juntaDirectiva += (registrocuentas[i].juntaDirectiva)
                   propina        += (registrocuentas[i].propina)

                   
                 

              } 

              
    
            

                var sql =  `SELECT * from empresas WHERE id = ${process.env.idEmpresa}`;
                const empresaData = await dbQuery(sql);
                
                    
                if(empresaData.length > 0){
                        name_empresa = empresaData[0].nombreComercial
                } 
                
                if(empresaData.Error){
                    res.status(200).send({ Error: 'Error db al buscar el empresa' })
                    db.end();
                    return   
                }
               
                var temp_data_platillos_anulados  = cierreFacturasPlatillos.filter(e => {
                    return (e.cancelacion == 1)
                  });


                  var temp_anul =  temp_data_platillos_anulados.map(item => item.platillo).filter((value, index, self) => self.indexOf(value) === index)
                  // console.log(temp)
                    var temp_cont_cantidad = 0
                   var array_object_temp_anulado = [] 
                   for(let i = 0; temp_anul.length > i; i++){
                    
                     var tipo_filtered = temp_data_platillos_anulados.filter(e => {
                       return (e.platillo == temp_anul[i])
                     });
                      temp_cont_cantidad = 0
                     
                     for(let j = 0; tipo_filtered.length > j; j++){
                       temp_cont_cantidad = temp_cont_cantidad  + parseInt(tipo_filtered[j].cantidad) 
                      
                       if(j == tipo_filtered.length-1){
                     
                        array_object_temp_anulado.push({
                            tipo: tipo_filtered[j].tipo,
                            platillo: tipo_filtered[j].platillo,
                            cantidad: temp_cont_cantidad,
                            precio: tipo_filtered[j].precio,
                            monto:(tipo_filtered[j].precio*temp_cont_cantidad).toFixed(2)
          
                          })
                       }
                     }
                   
                   }

              
                 
                var temp_data  = cierreFacturasPlatillos.filter(e => {
                return (e.cancelacion == 0)
                  });

                var array_object_temp = []
                
                var temp =  temp_data.map(item => item.platillo).filter((value, index, self) => self.indexOf(value) === index)
              
                var temp_cont_cantidad = 0
                
                for(let i = 0; temp.length > i; i++){
                 
                  var tipo_filtered = temp_data.filter(e => {
                    return (e.platillo == temp[i])
                  });
                   temp_cont_cantidad = 0
                  
                  for(let j = 0; tipo_filtered.length > j; j++){
                    temp_cont_cantidad = temp_cont_cantidad  + parseInt(tipo_filtered[j].cantidad) 
                   
                    if(j == tipo_filtered.length-1){
                  
                        array_object_temp.push({
                            tipo: tipo_filtered[j].tipo,
                            platillo: tipo_filtered[j].platillo,
                            cantidad: temp_cont_cantidad,
                            precio: tipo_filtered[j].precio,
                            monto:tipo_filtered[j].precio*temp_cont_cantidad
          
                          })
                    }
                  }
                
                }
              //  Array.prototype.push.apply(array_object_temp,array_object_temp_anulado); 
                var temp =  registrocuentas.map(item => item.idUsuarioAtendio).filter((value, index, self) => self.indexOf(value) === index)
       
                var temp_cont_cantidad_propina = 0
                var array_object_temp2 = []
                for(let i = 0; temp.length > i; i++){
                
                var tipo_filtered = registrocuentas.filter(e => {
                    return (e.idUsuarioAtendio == temp[i])
                });
                temp_cont_cantidad_propina = 0
                for(let j = 0; tipo_filtered.length > j; j++){
                    temp_cont_cantidad_propina = temp_cont_cantidad_propina  + parseInt(tipo_filtered[j].propina) 
                
                    if(j == tipo_filtered.length-1){
                        var userName = ''
                        sql = `SELECT userName from usuarios WHERE id = ${temp[i]}  AND idEmpresas = ${process.env.idEmpresa}`;
                        const dbUserName = await dbQuery(sql);

                        if(dbUserName.Error){
                            return res.status(200).send({ Error:  dbUserName.Error.toString()})
                        }
                        if(dbUserName){
                            userName = dbUserName[0].userName
                        }
                    
                    
                    array_object_temp2.push({
                        userName:userName,
                        propina: temp_cont_cantidad_propina.toFixed(2),
                    })
                    }
                }
                }
                //console.log(array_object_temp2)
              

                var options = {
                    format: "letter",
                    orientation: "portrait",
                    border: "5mm",
                    header: {
                        height: "28mm",
                        contents: {
                            first: '<div style="text-align: center;">Crockery App</div>'
                        }
                    },
                    footer: {
                        "height": "28mm",
                        "contents": {
                        first: name_empresa,
                        //2: 'Second page', // Any page number is working. 1-based index
                        //default: '<span style="color: #444;">{{page}}</span>/<span>{{pages}}</span>', // fallback value
                        last: ''
                        }
                    }
                }
                var html = fs.readFileSync(path.join(__dirname,'../../public/pdf-template.html'), 'utf8');

                array_object_temp.sort((a, b) => parseFloat(b.cantidad) - parseFloat(a.cantidad))

                sql = `SELECT descripcion from familiaNivel2 WHERE idEmpresas = '${process.env.idEmpresa}' ORDER BY ordenMenu ASC`;
                const family2order = await dbQuery(sql);
     
                if(family2order.Error){
                    return res.status(200).send({ Error:  family2order.Error.toString()})
                }
                //ORDENAR POR ORDEN DE MENU Y CANTIDAD DE PLATILLO  
                var temp_new_aray_object = []
                for(let i = 0; family2order.length > i; i++){
                  
                  var temp_platillos  = array_object_temp.filter(e => {
                   
                      return (e.tipo.trim().toLowerCase() == family2order[i].descripcion.trim().toLowerCase())
                  });
                  if(temp_platillos.length>0){
                    temp_platillos.sort((a, b) => parseFloat(b.cantidad) - parseFloat(a.cantidad));
                   
                    for(let i = 0; temp_platillos.length > i; i++){
                      temp_new_aray_object.push(temp_platillos[i])
                    }
                     
                  }
                  
                }
             
              var document = {
                  html: html,
                  data: {
                      ventaNeta: ventaNeta.toFixed(2),
                      propina: propina.toFixed(2),
                      efectivo:efectivo.toFixed(2),
                      bac:bac.toFixed(2),
                      visa:visa.toFixed(2),

                      credito:credito.toFixed(2),
                      cortesia:cortesia.toFixed(2),
                      descuento:descuento.toFixed(2),
                      juntaDirectiva:juntaDirectiva.toFixed(2),
                      glovoEfectivo:glovoEfectivo.toFixed(2),
                      glovoCredito:glovoCredito.toFixed(2),
                      hugoCredito:hugoCredito.toFixed(2),
                      cierrePlatillos:temp_new_aray_object,
                      platillosAnulados:array_object_temp_anulado,
                      usersPropina:array_object_temp2,
                      fecha:fechaBuscar,
                      totalglovo:(glovoEfectivo + glovoCredito).toFixed(2),
                      inputbac: params.inputbac,                     
                      inputVisa: params.inputVisa,                    
                      inputEfectivo: params.inputEfectivo,                
                      inputcredito: params.inputcredito,                
                      inputcortesia: params.inputcortesia,                
                      inputjuntadirectiva: params.inputjuntadirectiva,         
                      inputdescuento: params.inputdescuento,              
                      inputdolares: params.inputdolares,             
                      inputglovoCredito: params.inputglovoCredito,           
                      inputglovoefectivo: params.inputglovoefectivo,           
                      inputhugoCredito: params.inputhugoCredito,            
                      comentario: params.comentario,                   
    
                      
                     

                  },
                  path: "./../public/output.pdf",
                  phantomPath: "../node_modules/phantomjs/bin/phantomjs",
              };

              
             

            
                sql = `SELECT mailEmpresa from empresas WHERE id = ${process.env.idEmpresa}`;
                const toEmailAddress = await dbQuery(sql);
               
              
                if(toEmailAddress.Error){
                    res.status(200).send({Error:toEmailAddress.Error.toString()})
                    console.log(toEmailAddress.Error)
                    db.end();
                    return   
                }
                var toemail;
                console.log(toEmailAddress[0].mailEmpresa);
                if(toEmailAddress && toEmailAddress.length> 0){
                    toemail =   JSON.parse(toEmailAddress[0].mailEmpresa)
                }
                

                sql = `SELECT valor from empresaConfig WHERE idEmpresas = ${process.env.idEmpresa} AND opcion="asuntoCorreo"`;
                const emailSubject = await dbQuery(sql);

                if(emailSubject.Error){
                    res.status(200).send({Error:emailSubject.Error.toString()})
                    console.log(emailSubject.Error)
                    db.end();
                    return   
                }
               
                var subject = ""
                if(emailSubject.length>0 && emailSubject[0].valor){
                    subject = emailSubject[0].valor
                }
             
              
             await pdf.create(document, options)
              .then(res => {
                  console.log(res)
                 const  pathToAttachment = path.join(__dirname,'../../public/output.pdf');
                 const  attachment = fs.readFileSync(pathToAttachment).toString("base64");
                 emails.sendcorteCaja(toemail,attachment,fechaBuscar,subject)
              })
              .catch(error => {
                  console.error(error)
              });
            //  return   res.status(200).send({Error:"No se Encontro ningun Fondo de caja"})
             
             //if( Number( (ventaNeta-propina+descuento ).toFixed(2))==  Number( (cuadre ).toFixed(2))){
              if(true){
                     // console.log(ventaNeta-propina)
                      //console.log(cuadre)
                     
                     // return res.status(200).send(result)
                     // console.log("/////////////////////////")
                     // console.log("venta neta",ventaNeta)
                     // console.log("venta efectivo",efectivo)
                     // console.log("venta bac",bac)
                     // console.log("venta visa",visa)
                     // console.log("venta credito",credito)
                     // console.log("venta cortesia",cortesia)
                     // console.log("venta juntaDirectiva",juntaDirectiva)
                     // console.log("venta propina",propina)
                     // console.log("venta cuadre",cuadre)
                     // console.log("venta cuadre",ventaNeta-propina)
                     // console.log("/////////////////////////")
                     // console.log("")
                     // console.log("")
                      const  vantaTarjeta = bac+ visa //+hotel+cortesia+juntaDirectiva

                      let  sql = `SELECT * from fondoCaja   WHERE idSucursales=${req.user.idSucursales}  AND date_cierre IS NULL ORDER BY ID DESC LIMIT 1`;
                     
                      if((parseInt(process.env.CIERRE_CAJA_PER_USER))){
                            sql = `SELECT * from fondoCaja WHERE idSucursales=${req.user.idSucursales} AND idUsuarios=${req.user.id} AND date_cierre IS NULL ORDER BY ID DESC LIMIT 1`;
                      }
                      const fondoDecajaQ = await dbQuery( sql);
       
                     // console.log(fondoDecajaQ)
  
                      if(fondoDecajaQ.Error){
                        res.status(200).send({Error:fondoDecajaQ.Error})
                        db.end();
                        return   
                    }
                   // console.log(params)
                    const corteEnTarjetas=  parseInt(params.inputVisa) + parseInt(params.inputbac)
                    if(fondoDecajaQ && fondoDecajaQ.length>0){
                        const data_fondocaja = fondoDecajaQ[0]
                        const cierreData = {
                            fechaCorte: fechaBuscar,
                            fondoCaja:data_fondocaja.monto,
                            totalVales:0,
                            totalEfectivo:efectivo,
                            totalEfectivoDolares:0,
                            totalExenciones:0,
                            totalVouchers:vantaTarjeta,
                            totalCorte:params.inputEfectivo,
                            totalVentasContado:corteEnTarjetas+efectivo,
                            totalVentasCredito:credito,
                            diferencia:(params.inputEfectivo - efectivo - data_fondocaja.monto),
                            idUsuarios:req.user.id,
                            idSucursales:req.user.idSucursales,
                            idEmpresas:process.env.idEmpresa,
                            created_at:new Date(),
                            statusCierre:0,
                            comentario:params.comentario
                           
                        }
                       // console.log(cierreData)
                        sql = 'INSERT INTO corteCaja SET ?' 
                        const dataInset = await dbQuery( sql,cierreData);
         
    
                        if(fondoDecajaQ.Error){
                            res.status(200).send({Error:fondoDecajaQ.Error})
                            db.end();
                                return   
                        }
                      //  console.log(dataInset)
                      
                        if(dataInset && dataInset.insertId){
                             
                            for(let i = 0; registrocuentas.length > i; i++){
                               
                                let  sql2 = `UPDATE registrocuentas SET idcierreCaja = ${dataInset.insertId} WHERE id = ${registrocuentas[i].id} AND idEmpresas = '${process.env.idEmpresa}'`;
                               // console.log(sql2)
                               var inserDAta = await dbQuery(sql2);                        
                                if(inserDAta.Error){
                                    res.status(200).send({Error:fondoDecajaQ.Error})
                                    db.end();
                                        return   
                                }
                               
                             }
                             var datetime = new Date();
                             
                            let  sql4 = `UPDATE fondoCaja SET date_cierre = ${fechaBuscar}, comentario='${params.comentario}' WHERE idSucursales=${req.user.idSucursales}  AND date_cierre IS NULL ORDER BY ID DESC LIMIT 1`;
                           
                            if((parseInt(process.env.CIERRE_CAJA_PER_USER))){
                                sql4 = `UPDATE fondoCaja  SET date_cierre = ${fechaBuscar}, comentario='${params.comentario}' WHERE idSucursales=${req.user.idSucursales} AND idUsuarios=${req.user.id} AND date_cierre IS NULL ORDER BY ID DESC LIMIT 1`;
                            }
                            var updatedata1 = await dbQuery(sql4);                        
                            if(updatedata1.Error){
                                res.status(200).send({Error:fondoDecajaQ.Error})
                                db.end();
                                    return   
                            }

                            let  sql3 = `UPDATE corteCaja SET statusCierre = ${1} WHERE id = ${dataInset.insertId} AND idEmpresas = '${process.env.idEmpresa}' AND idSucursales =  ${req.user.idSucursales}`;
                            if((parseInt(process.env.CIERRE_CAJA_PER_USER))){
                                 sql3 = `UPDATE corteCaja  SET statusCierre = ${1} WHERE id = ${dataInset.insertId} AND idEmpresas = '${process.env.idEmpresa}' AND idSucursales =  ${req.user.idSucursales} AND idUsuarios=${req.user.id} `;
                            }
                              updatedata1 = await dbQuery(sql3);                        
                             if(updatedata1.Error){
                                res.status(200).send({Error:fondoDecajaQ.Error})
                                 db.end();
                                     return   
                             }
                            
                             sql3 = `UPDATE usuarios SET token = '' WHERE idEmpresas = ${process.env.idEmpresa}  AND idSucursales =  ${req.user.idSucursales}`;
                             
                             if((parseInt(process.env.CIERRE_CAJA_PER_USER))){
                                  sql3 = `UPDATE usuarios   SET token = '' WHERE idEmpresas = ${process.env.idEmpresa}  AND idSucursales =  ${req.user.idSucursales} AND idSucursales =  ${req.user.idSucursales} AND id=${req.user.id} `;
                             }
                             updatedata1 = await dbQuery( sql3); 
                             if(updatedata1.Error){
                                res.status(200).send({Error:fondoDecajaQ.Error})
                                db.end();
                                    return   
                            } 
                            res.status(200).send({data:registrocuentas})
                             db.end();
                             return 
                        }else{
                            res.status(200).send({ Error: 'db  Corte Caja' })
                            db.end();
                            return 
                        }
                       
                       
                      
                    }else{
                        return   res.status(200).send({Error:"No se Encontro ningun Fondo de caja"})
                    }
                      
                   
                     
            }else{
                res.status(200).send({ Error: 'Cantidades No Coinciden' })
                db.end();
                return 
            }
                
              
          }else{
            res.status(200).send({ Error: 'No se encontro ninguna cuenta abierta para esta fecha' })
              db.end();
              return 
          }


       

      
    }catch (error) {
        console.log(error)
        res.status(200).send({Error:error.toString()})
        db.end()
        return 
    }
    //console.log(fechaBuscar)
    //let fechaSiguiente = Date(fechaBuscar).setDate(Date(fechaBuscar).getDate() + 1)
    // var fechaBuscarSplit = fechaBuscar.split('');
   
    
   /* Factura.find( { fechaCierre: fechaBuscar}, (err, encontrados) => {
        
        if (err) {
            res.status(500).send(err)
        } else {
            if (!encontrados) {
                res.status(404).send({ message: 'No se pudo buscar las facturas' })
            } else {
                res.status(200).send(encontrados)
             //   console.log(encontrados)
            }
        }
    })*/

}
function validateNit(req, res) {
    let nit = req.params.nit
   
  console.log(nit)
    const url = "https://www.ingface.net/ServiciosIngface/ingfaceWsServices"
   var xml_data = `<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:ser="http://services.ws.ingface.com/">
                    <soapenv:Header/>
                    <soapenv:Body>
                       <ser:nitContribuyentes>
                          <!--Optional:-->
                          <usuario>CONSUMO_NIT</usuario>
                          <!--Optional:-->
                          <clave>58B45D8740C791420C53A49FFC924A1B58B45D8740C791420C53A49FFC924A1B</clave>
                          <nit>${nit}</nit>
                       </ser:nitContribuyentes>
                    </soapenv:Body>`;
        var options = {
            method: 'POST',
            keepAlive: false,
            url: url,
            headers: {
            'Content-Type': 'Content-Type: text/xml',
            'Accept-Encoding': 'gzip',
            },
            body: xml_data,
            gzip: true //depending on the webservice, this has to be false
        };

      var x = request(options, function (error, response, body) {
        //I convert the response to JSON. This is not mandatory
        if(error){
            console.log("ERROR")
            console.log(error)
            return res.status(200).send({Error:error})
            
        }
        var parser = new xml2js.Parser({explicitArray: false, trim: true});
        parser.parseString(body, function (err, result) {
            
           if(err){
            console.log(err)
            return res.status(200).send({Error:err})
           }
           const data_resp = result['S:Envelope']['S:Body']['ns2:nitContribuyentesResponse'].return
           // console.log(data_resp);
            return res.status(200).send(data_resp)
          
           
        });
       
      });
   
}


async function reprintFactura(data,productos,printeripAddress,piepagina,dateEmpresa){
   
    
    const items = productos
    var printer_temp = ''
    if(printeripAddress && printeripAddress.length > 0){
        printer_temp =  printeripAddress[0].ipAddress
       
    }else{
        return false
    }

    let printer = new ThermalPrinter({type: Types.EPSON, interface: printer_temp.toString()});
    let printerConnection =  await printer.isPrinterConnected();
    console.log("Printer factura connected 100:"+ printer_temp.toString(), printerConnection);

    /*if(printerConnection == false){
        return false
    }*/
    
    await printer.newLine();

    await printer.alignCenter();
    await printer.printImage('./assets/logoblanco.png');
    await printer.newLine();

    await printer.bold(true);
    await printer.println(dateEmpresa.nombreComercial ? dateEmpresa.nombreComercial: ''); //empresas.nombreComercial
    await printer.bold(false);
    await printer.newLine();

    await printer.println(dateEmpresa.direccion ? dateEmpresa.direccion : ''); //empresas.direccion
    await printer.println(dateEmpresa.razonSocial ? dateEmpresa.razonSocial: ''); //empresas.razonsocial
    await printer.println("Nit: " + (dateEmpresa.nit ? dateEmpresa.nit: '')); //empresas.nit
    await printer.newLine();

    await printer.setTextSize(0,0);
    await printer.println('Factura Electronica');
    await printer.println('Autorizacion:');
    await printer.println(data.autorizacionFEL);
    await printer.println('Fecha Certificacion: ' + data.fechaEmisionFEL);
    await printer.newLine();

    
    await printer.alignLeft();
    await printer.println('Serie: '+ data.serie);
    await printer.println('Numero: '+ data.correlativo);
    await printer.println('NIT: '+ dateEmpresa.nit);
    await printer.println('Fecha de Emision: '+data.fechaFactura);
    await printer.newLine(); 

    await printer.alignLeft();
    await printer.println('NIT: '+data.nit);
    await printer.println('Nombre: '+data.nombre);
    await printer.println('Direccion: '+data.direccion);
    await printer.newLine();  

    await printer.drawLine();

        if(true){
            await printer.tableCustom([
                { 
                    text:"Cant.",
                    align:"LEFT", 
                    width:0.15
                },
                { 
                    text: "Descripcion", 
                    align:"LEFT", 
                    width:0.64
                },
                { 
                    text: "Total",
                    align:"LEFT", 
                    width:0.20 
                }
            ]);
        
            var index = 0
            while (index< items.length) {
                //if(!items[index].cancelacion){
                    await printer.tableCustom([
                        { 
                            text: items[index].cantidad,
                            align:"LEFT", 
                            width:0.15
                        },
                        { 
                            text: items[index].descLarga, 
                            align:"LEFT", 
                            width:0.64
                        },
                        { 
                            text: "Q." + (parseInt(items[index].precio) * parseInt(items[index].cantidad))  + ".00",
                            align:"LEFT", 
                            width:0.20
                        }
                    ]);
                   
                 //}
                 index = index +1
            }
        }else if(false){
            await printer.tableCustom([
                { 
                    text:"",
                    align:"LEFT", 
                    width:0.15
                },
                { 
                    text: "Descripcion", 
                    align:"LEFT", 
                    width:0.64
                },
                { 
                    text: "Total",
                    align:"LEFT", 
                    width:0.20 
                }
            ]);
             
            await printer.tableCustom([
                    { 
                        text: '',
                        align:"LEFT", 
                        width:0.15
                    },
                    { 
                        text: items.descripcion, 
                        align:"LEFT", 
                        width:0.64
                    },
                    { 
                        text: items.subtotal,
                        align:"LEFT", 
                        width:0.20
                    }
                ]);
        }
    
      
        await printer.drawLine();

        await printer.alignRight();
        await printer.println('Sub-Total: Q ' + data.subtotal);
       // await printer.println('Propina: Q ' + data.propina);
        if(data.descuento > 0){
            await printer.println('Descuento:  - Q ' + data.descuento);
        }
        await printer.bold(true);
        await printer.println('TOTAL: Q ' + data.total);
        await printer.bold(false);
        await printer.alignCenter();
        //await printer.println('TRANSACCION: ' + data.idVentas);
        await printer.newLine(); 

        await printer.println(dateEmpresa.website);     
        await printer.newLine(); 

        await printer.println(piepagina.line1 ? piepagina.line1 : '');
        await printer.println(piepagina.line2 ? piepagina.line2 : '');
        await printer.println(piepagina.line3 ? piepagina.line3 : '');
        await printer.println(piepagina.line4 ? piepagina.line4 : '');
        await printer.newLine(); 

        await printer.alignCenter();
        await printer.bold(true);
        await printer.println('Documento Eletronico');
        await printer.println('Sujeto a pagos trimestrales');
        await printer.bold(false);
        await printer.println('DIGIFACT, S.A');
        await printer.println('NIT: 77454820');
        await printer.drawLine(); 
        await printer.println('powered by Proper')
        await printer.println('www.somosproper.com')

        await printer.newLine();


        await printer.cut();

       
 
        console.log(printer.getText());
        

        if(printerConnection == false){
            return false
        }

    try {
        //console.log("EXECUTE!")
        let execute =   printer.execute();
        return true;
      } catch (error) {
        const errorMessage = "Error de Conexion en Impresora "
        console.log(error)
        return false;
       
      }
  
   
    
}

async function re_imprimirFactura_recibo(req, res) {
    let idVenta = req.params.idventa
    console.log(idVenta)

    const db =sqldb()
    const dbQuery = util.promisify(db.query).bind(db);
    //let  sql = `SELECT * from ventas WHERE idEmpresas = ${process.env.idEmpresa}`
    let  sql = `SELECT * from ventasDetalle WHERE idEmpresas = ${req.user.idEmpresas} AND idVentas = ${idVenta}`
    const productos = await dbQuery(sql);
    if(productos.Error){
        console.log(productos.Error)
        res.status(200).send({Error:productos.Error.toString()})
        db.end();
        return   
    } 
    const dataempresa1 = await dbQuery( `SELECT * FROM empresas where id = ${process.env.idEmpresa}` );
    if(dataempresa1.Error){
        console.log(dataempresa1.Error)
        res.status(200).send({Error:dataempresa1.Error})
        db.end();
        return   
    }
    const piepaginaprinter2 = await dbQuery( `SELECT * FROM pirnterpiepagina where idSucursales=${req.user.idSucursales} AND idEmpresas = ${parseInt(process.env.idEmpresa)} ` );
    if(piepaginaprinter2.Error){
        console.log(piepaginaprinter2.Error)
        res.status(200).send({Error:registrocuentas.Error})
        db.end();
        return   
    }
    
    sql = `SELECT ipAddress from area_Impresoras WHERE  idUsuario = ${req.user.id} AND idEmpresas = '${process.env.idEmpresa}' `; 
    var printerdata2 = await dbQuery(sql);
    if(printerdata2.Error){
        console.log(printerdata2.Error)
        res.status(200).send({Error:printerdata2.Error.toString()})
        db.end();
        return   
    }

    if(printerdata2.length == 0){
        sql = `SELECT ipAddress from area_Impresoras WHERE  idareaImpresora = 1 AND idEmpresas = '${process.env.idEmpresa}' `; 
         printerdata2 = await dbQuery(sql);
        if(printerdata2.Error){
            console.log(printerdata2.Error)
            res.status(200).send({Error:printerdata2.Error.toString()})
            db.end();
            return   
        }
    }
   
    
   
    //console.log(printerdata2)
    const factrespPrinter = await  reprintFactura(req.body,productos,printerdata2,piepaginaprinter2[0],dataempresa1[0])
    //console.log(factrespPrinter)
    if(factrespPrinter){
        return res.status(200).send({succes:"Impresion Exitosa"})
    }
    return res.status(200).send({Error:"Error de Conexion en Impresora "})
}

async function anularFacturaController(req, res) {

    console.log("anularFacturaController")
    const params = req.body

   
    const db =sqldb()
    const dbQuery = util.promisify(db.query).bind(db);
    var sql = ""
    if(params.tipoTransaccion.tipo == 1 &&  params.anulacion.tipo == 0){
        sql = `SELECT *, LPAD(nit,12,0) as nitEmisor from empresas where id = '${process.env.idEmpresa}'`
        const dbFactEmpresa = await dbQuery(sql);
        if(dbFactEmpresa.Error){
            console.log(dbFactEmpresa.Error)
            res.status(200).send({Error:dbFactEmpresa.Error.toString()})
            db.end();
            return  
        } 
        db.end();
        const dataempresa = dbFactEmpresa[0]
        
       // console.log(dbFactEmpresa)
        //URL ANULACION
        const urlanulacion = process.env.FEL_URL +   "?NIT=" + dataempresa.nitEmisor + "&TIPO=ANULAR_FEL_TOSIGN&FORMAT=XML"
        const token = process.env.FEL_TOKEN

        const nowDate = new Date().toLocaleString('en-US', {
            timeZone: 'America/Guatemala'
          });
         // console.log(nowDate)
        const timGt = (new Date(nowDate)).toISOString()
      
       // console.log(timGt)
        const date_ = nowDate.split(',')
        const fechaAnulacion = date_[0].trim()
        const horaAnulacion = date_[1].trim()

        console.log(fechaAnulacion,horaAnulacion)
        console.log(urlanulacion)
        var xml_data_anulacion = `<?xml version="1.0" encoding="utf-8"?>
        <dte:GTAnulacionDocumento xmlns:dte="http://www.sat.gob.gt/dte/fel/0.1.0"
            xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" Version="0.1">
            <dte:SAT>
                <dte:AnulacionDTE ID="DatosCertificados">
                    <dte:DatosGenerales ID="DatosAnulacion"
                        NumeroDocumentoAAnular="'${params.autorizacionFEL}'" 
                        NITEmisor="'${dataempresa.nit}'"
                        IDReceptor="'${params.nit}'" 
                        FechaEmisionDocumentoAnular="'${params.fechaEmisionFEL}'"
                        FechaHoraAnulacion="'${fechaAnulacion}'T'${horaAnulacion}'"
                        MotivoAnulacion="'  '"/>         
                </dte:AnulacionDTE>
            </dte:SAT>
        </dte:GTAnulacionDocumento>`;
        console.log(xml_data_anulacion)

        var options = {
            method: 'POST',
            keepAlive: false,
            url: url2,
            headers: {
               'Authorization':token2,
               'Content-Type': 'Content-Type: text/xml',
               'Accept-Encoding': 'gzip'
            },
            body: xml_data,
            gzip: true //depending on the webservice, this has to be false
        };

        
   
    process.env["NODE_TLS_REJECT_UNAUTHORIZED"] = 0;
    var x = request(options, async function (error, response, body) {
        //I convert the response to JSON. This is not mandatory
            
        if(error){
            console.log("ERROR")
            console.log(error)
            return   res.status(200).send({Error:error.toString()})
        }else{
            var fel_data = JSON.parse(body)
             console.log("fel_data",fel_data.Codigo) 
            if(fel_data.Codigo == 1){
 
            }else{
                

                return res.status(200).send({Error:"Fel " + fel_data.ResponseDATA1.toDateString()})
            }
        }
      
     }) 
     return res.status(200).send({Error:"EXITO FACTURA"})
     return 
        
       
       
    }else if(params.tipoTransaccion.tipo == 0 &&  params.anulacion.tipo == 0){
        return res.status(200).send({Error:"EXITO RECIBO"})
    }else{
        return res.status(200).send({Error:"El documento ya fue anulado"})
      
    }
    return res.status(200).send({Error:"ANULAR FACTURA"}) 

    
  


/*
    public function anulacionFactura($params){
        //CONSULTA DATOS VENTA (FACTURA)
        $sqlV= "select anulacion, autorizacionFEL, fechaEmisionFEL, nit as nitReceptor, tipoTransaccion  from ventas where idEmpresas=" . $params['idEmpresas'] . " and id= " . $params['idVenta'] . " ;";
        $queryV = mysql_query($sqlV, dbCon::con($params['dbName']));
        $dataV = mysql_fetch_assoc($queryV);
        
        //Validar que sea factura y que no este anulado
        if ($dataV['tipoTransaccion'] == 1 && $dataV['anulacion'] == 0) {
            //$responseF = "";
            //CONSULTA DATOS EMPRESA
            $sqlE = "select *, lpad(nit,12,0) as nitEmisor from empresas where id=" . $params['idEmpresas'] . ";";
            $queryE = mysql_query($sqlE, dbCon::con($params['dbName']));
            $regE = mysql_fetch_assoc($queryE);
            
            //URL ANULACION 
            
            $URL =  $params['urlFEL'] . "?NIT=" . $regE['nitEmisor'] . "&TIPO=ANULAR_FEL_TOSIGN&FORMAT=XML";
            $token = $params['tokenFEL'];
            date_default_timezone_set("America/Guatemala");
            //GENERACION DE XML
            $fechaAnulacion = $this->date;
            $horaAnulacion = $this->time;
            $xml_data = '<?xml version="1.0" encoding="utf-8"?>
                        <dte:GTAnulacionDocumento xmlns:dte="http://www.sat.gob.gt/dte/fel/0.1.0"
                            xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" Version="0.1">
                            <dte:SAT>
                                <dte:AnulacionDTE ID="DatosCertificados">
                                    <dte:DatosGenerales ID="DatosAnulacion"
                                        NumeroDocumentoAAnular="' . $dataV['autorizacionFEL'] . '" 
                                        NITEmisor="' . $regE['nit'] . '"
                                        IDReceptor="' . $dataV['nitReceptor'] . '" 
                                        FechaEmisionDocumentoAnular="'. $dataV['fechaEmisionFEL'] .'"
                                        FechaHoraAnulacion="'. $fechaAnulacion . 'T' . $horaAnulacion . '"
                                        MotivoAnulacion="' . trim($params['motivo']) . '"/>         
                                </dte:AnulacionDTE>
                            </dte:SAT>
                        </dte:GTAnulacionDocumento>';
            $ch = curl_init($URL);
            curl_setopt($ch, CURLOPT_MUTE, 1);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: text/xml', 'Authorization: ' . $token . ''));
            curl_setopt($ch, CURLOPT_POSTFIELDS, "$xml_data");
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            $output = curl_exec($ch);
            curl_close($ch);
            $response = json_decode($output, true);
            if ($response['Codigo'] == 1) {
                $sqlUpadate = "update ventas set anulacion=1, idAdminUser=" . $params['idUsuarios'] . ", motivoAnulacion='" . trim($params['motivo']) . "', reciboAnulacion='" .  $response['AcuseReciboSAT'] . "', anulacion_at ='" . $fechaAnulacion . " " . $horaAnulacion . "' where id=" . $params['idVenta'] . " and idEmpresas=" . $params['idEmpresas'] . ";";
                $queryUpdate = mysql_query($sqlUpadate, dbCon::con($params['dbName']));
                
                if ($queryUpdate) {
                    $responseF = array('message' => 'success'); 
                } else {
                    $responseF = array('message' => 'database', 'query' => $sqlUpadate);
                }
            } else {
                $responseF = array('message' => 'error', 'error' => $response['ResponseDATA1'], 'XML' => $xml_data);
            }
        }
        else if ($dataV['tipoTransaccion'] == 0 && $dataV['anulacion'] == 0) {
            // Anulacion de Recibo
            $sqlUpadate = "update ventas set anulacion=1, idAdminUser=" . $params['idUsuarios'] . ", motivoAnulacion='" . trim($params['motivo']) . "', anulacion_at ='" . $fechaAnulacion . " " . $horaAnulacion . "' where id=" . $params['idVenta'] . " and idEmpresas=" . $params['idEmpresas'] . ";";
            $queryUpdate = mysql_query($sqlUpadate, dbCon::con($params['dbName']));
                
            if ($queryUpdate) {
                $responseF = array('message' => 'success'); 
            } else {
                $responseF = array('message' => 'database', 'query' => $sqlUpadate);
            }
        }
        else {
            $responseF = array('error' => 'El documento ya fue anulado');
        }
        return $responseF;
    }*/
}
module.exports = {
    guardarFactura,
    actualizarFactura,
    eliminarFactura,
    listarFacturas,
    buscarFactura,
    buscarPorFecha,
    validateNit,
    printTickets,
    getFondoCaja,
    getTasaDeCambio,
    setFondoCaja,
    generarCierrredeCaja,
    re_imprimirFactura_recibo,
    anularFacturaController
}


