'use strict';

var Ticket = require('../models/ticket');

const ThermalPrinter = require("node-thermal-printer").printer;
const Types = require("node-thermal-printer").types;

function printTickets(req, res){

    let params = req.body;
    
    let pKiosco = new ThermalPrinter({type: Types.EPSON, interface: 'tcp://192.168.2.100'});
    let cnKiosco = pKiosco.isPrinterConnected();
    console.log("Printer Kiosco connected 100:", cnKiosco);

    let items = params.actividades;
    for (const item of items) {
        let actNom = getNombreActividad(item.codigo);

        for (let i = 0; item.cantidad > i; i++){
            // let corrStr = '';
        // let ceros = '';

        // corrStr += correlativo;

        // for(let c = corrStr.length; c < 6; c++){
        //     ceros += '0';
        // }

        // corrStr = items[i].codigo + ceros + corrStr;
        
        pKiosco.newLine();    
        pKiosco.newLine(); 

        // pKiosco.printImage('./assets/logoblanco_sm.png')
        // pKiosco.println(corrStr);
        pKiosco.newLine(); 

        pKiosco.bold(true);
        pKiosco.alignCenter();
        pKiosco.println(actNom);
        pKiosco.bold(false);
        
        pKiosco.alignLeft();
        pKiosco.println('No nos responsabilizamos por los accidentes y/o heridas causadas al utilizar las atracciones, usted se sube bajo su cuenta y riesgo. Si el usuario no tiene un adecuado manejo de las atracciones el personal tiene la autoridad de retirarlo sin devoluciones.');

        pKiosco.newLine(); 
        pKiosco.cut();

        pKiosco.drawLine();
        pKiosco.newLine();    
        }
        
    }

    pKiosco.newLine();
    pKiosco.newLine();
    pKiosco.setTextSize(1,0);
    pKiosco.bold(true);
    pKiosco.alignCenter(); 
    pKiosco.printImage('./assets/logoblanco.png');
    pKiosco.println("ESTADO DE CUENTA");
    pKiosco.println("COPIA DEL CLIENTE");
    pKiosco.bold(false);
    pKiosco.setTextNormal(); 

    pKiosco.alignLeft(); 
    pKiosco.println("Usuario: " + params.usuarioAtendio);
    pKiosco.drawLine();

    pKiosco.tableCustom([
        { 
            text:"Cant.",
            align:"LEFT", 
            width:0.15
        },
        { 
            text: "Descripcion", 
            align:"LEFT", 
            width:0.64
        },
        { 
            text: "Total",
            align:"LEFT", 
            width:0.20 
        }
    ]);

    for (const item of items) {
        pKiosco.tableCustom([
            { 
                text: item.cantidad,
                align:"LEFT", 
                width:0.15
            },
            { 
                text: item.nombre, 
                align:"LEFT", 
                width:0.64
            },
            { 
                text: "Q." + item.total + ".00",
                align:"LEFT", 
                width:0.20
            }
        ]);
    }

    pKiosco.drawLine();
    
    pKiosco.tableCustom([
        {text: "Total", align:"LEFT", width:0.75},
        {text: "Q." + params.total + ".00", align:"LEFT", width:0.25}
    ]);

    pKiosco.newLine();
    pKiosco.newLine();
    pKiosco.cut();

    pKiosco.newLine();
    pKiosco.newLine();
    pKiosco.setTextSize(1,0);
    pKiosco.bold(true);
    pKiosco.alignCenter(); 
    pKiosco.println("ESTADO DE CUENTA");
    pKiosco.println("CONTROL DE CAJA");
    pKiosco.bold(false);
    pKiosco.setTextNormal(); 

    pKiosco.alignLeft(); 
    pKiosco.println("Usuario: " + params.usuarioAtendio);
    pKiosco.drawLine();

    pKiosco.tableCustom([
        { 
            text:"Cant.",
            align:"LEFT", 
            width:0.15
        },
        { 
            text: "Descripcion", 
            align:"LEFT", 
            width:0.64
        },
        { 
            text: "Total",
            align:"LEFT", 
            width:0.20 
        }
    ]);

    for (const item of items) {
        pKiosco.tableCustom([
            { 
                text: item.cantidad,
                align:"LEFT", 
                width:0.15
            },
            { 
                text: item.nombre, 
                align:"LEFT", 
                width:0.64
            },
            { 
                text: "Q." + item.total + ".00",
                align:"LEFT", 
                width:0.20
            }
        ]);
    }

    pKiosco.drawLine();
    
    pKiosco.tableCustom([
        {text: "Total", align:"LEFT", width:0.75},
        {text: "Q." + params.total + ".00", align:"LEFT", width:0.25}
    ]);

    pKiosco.newLine();
    pKiosco.newLine();
    pKiosco.cut();

    // console.log(pKiosco.getText()); 
    pKiosco.execute();
    return res.status(200).send('done!');
    // items.forEach(item =>{

    //     let actNom = getNombreActividad(item.codigo);
    //     console.log(actNom);

    //     getTicketCorr(item.codigo, function(correlativo) {
    //         let corrStr = '';
    //         let ceros = '';

    //         corrStr += correlativo;

    //         for(let c = corrStr.length; c < 6; c++){
    //             ceros += '0';
    //         }

    //         corrStr = items[i].codigo + ceros + corrStr;
            
    //         let pKiosco = new ThermalPrinter({type: Types.EPSON, interface: 'tcp://192.168.2.100'});
    //         let cnKiosco = pKiosco.isPrinterConnected();
    //         console.log("Printer Kiosco connected 100:", cnKiosco);

    //         pKiosco.newLine();    
    //         pKiosco.newLine(); 
    
    //         // pKiosco.printImage('./assets/logoblanco_sm.png')
    //         pKiosco.println(corrStr);
    //         pKiosco.newLine(); 

    //         pKiosco.bold(true);
    //         pKiosco.alignCenter();
    //         pKiosco.println(actNom);
    //         pKiosco.bold(false);
            
    //         pKiosco.alignLeft();
    //         pKiosco.println('No nos responsabilizamos por los accidentes y/o heridas causadas al utilizar las atracciones, usted se sube bajo su cuenta y riesgo. Si el usuario no tiene un adecuado manejo de las atracciones el personal tiene la autoridad de retirarlo sin devoluciones.');

    //         pKiosco.newLine(); 
    //         // pKiosco.cut();

    //         pKiosco.drawLine();
    //         pKiosco.newLine();    
    //         console.log(pKiosco.getText()); 
    //     });
    

    // });
    // console.log(params);
    // return res.status(200).send(params);
    
}

function getTicketCorr(actcod, corr){

    Ticket.find({codigo: actcod}, (err, found) => {
        if(err){
            console.log('error');
            return 1;
        } else {
            if (!found){
                return 1;
            }
            else{
                corr = found[0].correlativo;
                
                let nCorr = found[0].correlativo + 1;
                addTicketCorr(actcod, nCorr);
                return corr;
                
            }
        }
    });
}

function addTicketCorr(actcod, nCorr){
    Ticket.findOneAndUpdate(
        {codigo: actcod},
        {correlativo: nCorr},
        (err, updated) => {
            if(err){
                console.log(err);
            }
        }
    );
}

function getNombreActividad(actcod){
    switch(actcod){
        case 'ACT1':
            return 'PASEO A LA MONTAÑA ADULTO';    
        case 'ACT2':
            return 'PASEO A LA MONTAÑA NIÑO';
        case 'ACT3':
            return 'CANOPY PEQUEÑO';
        case 'ACT4':
            return 'CANOPY DE MONTAÑA';
        case 'ACT5':
            return 'GO KART';
        case 'ACT6':
            return 'VUELTA A CABALLO';    
        case 'ACT7':
            return 'PASEO A LA MONTAÑA - EVENTO';
        case 'ACT8':
            return 'CANOPY PEQUEÑO - EVENTO';
        case 'ACT9':
            return 'CANOPY MONTAÑA - EVENTO';
        case 'ACT10':
            return 'GO KART - EVENTO';
        default:
            return 'ACTIVIDAD';
    }
}

module.exports = {
    printTickets
}