'use strict';

const Usuario = require('../models/user');
var {sqldb} = require('../db/sqlconnection')
const {generateAuthToken} = require('../auth/generate_token')
const util = require('util');


//----------------------------guarda usuario -------------------//
 
function crearUsuario(req, res) {
    let params = req.body;
    let usuario = new Usuario();

    if (params.nombre && params.apellido && params.nombreDeUsuario && params.pin && params.rol) {
        usuario.nombre = params.nombre;
        usuario.apellido = params.apellido;
        usuario.nombreDeUsuario = params.nombreDeUsuario;
        usuario.pin = params.pin;
        usuario.rol = params.rol;

        usuario.save((err, userSave) => {
            if (err) {
                res.status(500).send({ message: 'Erro al guardar Usuario' });
            }
            else {
                if (!userSave) {
                    res.status(404).send({ message: 'No se pudo guardar Usuario' });
                }
                else {
                    res.status(200).send({ usuarios: userSave });
                }
            }
        })
    }
    else {
        res.status(200).send({ message: 'Ingrese los datos requeridos' });
    }
}

function actualizarUsuario(req, res) {
    let params = req.body;
    let userID = req.params.id;

    Usuario.findByIdAndUpdate(userID, params, { new: true }, (err, userActualizado) => {
        if (err) {
            res.status(500).send({ message: 'Error al actualizar usuario' });
        }
        else {
            if (!userActualizado) {
                res.status(404).send({ message: 'No se pudo actualizar usuario' });
            } else {
                res.status(200).send({ userActualizado });
            }
        }
    });
}

function eliminarUsuario(req, res) {
    let userID = req.params.id;

    Usuario.findByIdAndDelete(userID, (err, userEliminado) => {
        if (err) {
            res.status(500).send({ message: 'Error al eliminar Usuario' });
        } else {
            if (!userEliminado) {
                res.status(404).send({ message: 'Error al eliminar Usuario' });
            } else {
                res.status(200).send({ message: 'El usuario ha sido eliminado' });
            }
        }
    });
}

const  listarUsuarios = async(req, res) => {

    //const idEmpresas = 1
    let  sql = `SELECT * from usuarios WHERE idEmpresas = ${process.env.idEmpresa}`
    const db =sqldb()
    let query = db.query(sql,(err,results)=>{
      
        if (err) {
            db.end();
            res.status(500).send({ message: 'Error al listar Usuarios' })
        } else {
            if (!results) {
                db.end();
                res.status(404).send({ message: 'No hay Usuarios' })
            } else {
                db.end();
                res.status(200).send(results)
            }
        }
    })

  /* Usuario.find((err, encontrado) => {
        if (err) {
            res.status(500).send({ message: 'Error al listar Usuarios' })
        } else {
            if (!encontrado) {
                res.status(404).send({ message: 'No hay Usuarios' })
            } else {
                res.status(200).send(encontrado)
            }
        }
    })*/
}

function buscarUsuario(req, res) {
    var userID = req.params.id;

    Usuario.findById(userID, (err, encontrado) => {
        if (err) {
            res.status(500).send({ message: 'Error al buscar' });
        } else {
            if (!encontrado) {
                res.status(404).send({ message: 'Error al buscar usuario' })
            } else {
                res.status(200).send(encontrado)
            }
        }
    })
}
async function login(req, res) {
    var userID = req.params.id;
    var password = req.params.pin;
    var npmbreuser = req.params.username
   
   
    let  sql = ``;
    var name_empresa = ''
    const db =sqldb()
    try{ 
        const dbQuery = util.promisify(db.query).bind(db);
          sql =  `SELECT * from empresas WHERE id = ${process.env.idEmpresa}`;
        const empresaData = await dbQuery(sql);
       
        
       if(empresaData.length == 0){
        return   res.status(200).send({ message: 'Error al buscar el empresa' })
       } 
       name_empresa = empresaData[0].nombreComercial
    if(empresaData.Error){
        db.end();
        return   res.status(200).send({ message: 'Error db al buscar el empresa' })
    }
    }catch(e){
        return   res.status(200).send({ message: 'Error db al buscar el empresa' })
    }
    sql = `SELECT * from usuarios WHERE id = ${userID} AND codigoUsuario = ${password} AND userName='${npmbreuser}'`;
    let query = db.query(sql,(err,result)=>{
        
    
        if(result){
            const resp = result[0]
            if(!resp){
                db.end();
                res.status(200).send({message: 'No se pudo encontrar el usuario'})
            }else if(err)    {
                db.end();
                res.status(200).send({ message: 'Error al buscar el usuario' })
            }else{
                const token = generateAuthToken(resp)
                let sql1 = `UPDATE usuarios SET token = '${token}' WHERE id = ${userID}`;
            
                db.query(sql1,(err,result)=>{
                    if(err){
                        db.end();
                        res.status(200).send({message: 'SQL UPDATE ERROR'})
                    }else{
                       
                        db.end();
                        res.status(200).send({token:token,rol:resp.rol,username:resp.user,rol:resp.idRoles,nombreEmpresa:name_empresa})
                    }
                   
                })
               
            }


        }
      
      
        

       
    })
    


    
   /* Usuario.findOne({ _id: userID, pin: password }, (err, encontrado) => {
        if(err) {
            res.status(200).send({ message: 'Error al buscar el usuario' })
        } else {
            if(!encontrado) {
                res.status(200).send({message: 'No se pudo encontrar el usuario'})
            } else {
                res.status(200).send(encontrado)
            }
        }
    })*/
   
}
function logout (req, res) {
  
    var userID = req.user.id;
    let sql = `UPDATE usuarios SET token = '' WHERE id = ${userID}`;
    const db =sqldb()       
    db.query(sql,(err,result)=>{
        if(err){
            db.end();
            res.status(200).send({message: 'SQL UPDATE ERROR'})
        }else{
            db.end();
            res.status(200).send(true)
        }
        
       
    })
    
}


module.exports = {
    logout,
    crearUsuario,
    actualizarUsuario,
    eliminarUsuario,
    listarUsuarios,
    buscarUsuario,
    login
}